import { NgModule } from '@angular/core';
import { RouterModule, Routes } from '@angular/router';
import { CheckTutorial } from './providers/check-tutorial.service';

const routes: Routes = [
  {
    path: '',
    //redirectTo: '/tutorial',
    //redirectTo: '/login',
    loadChildren: () => import('./pages/login/login.module').then(m => m.LoginModule),
    pathMatch: 'full'
  },
  {
    path: 'account',
    loadChildren: () => import('./pages/account/account.module').then(m => m.AccountModule)
  },
  {
    path: 'support',
    loadChildren: () => import('./pages/support/support.module').then(m => m.SupportModule)
  },
  {
    path: 'login',
    loadChildren: () => import('./pages/login/login.module').then(m => m.LoginModule),
    
  },
  {
    path: 'signup',
    loadChildren: () => import('./pages/signup/signup.module').then(m => m.SignUpModule)
  },
  {
    path: 'app',
    loadChildren: () => import('./pages/tabs-page/tabs-page.module').then(m => m.TabsModule)
  },
  {
    path: 'tutorial',
    loadChildren: () => import('./pages/tutorial/tutorial.module').then(m => m.TutorialModule),
    canLoad: [CheckTutorial]
  },
  {
    path: 'resumo-diario',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/resumo-diario/resumo-diario.module').then( m => m.ResumoDiarioPageModule)
  },   {
    path: 'vendas-mensal',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/vendas-mensal/vendas-mensal.module').then( m => m.VendasMensalPageModule)
  },
  {
    path: 'vendas-mensal-detalhe',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/vendas-mensal-detalhe/vendas-mensal-detalhe.module').then( m => m.VendasMensalDetalhePageModule)
  },
  {
    path: 'vendas-grafico-comparativo',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/vendas-grafico-comparativo/vendas-grafico-comparativo.module').then( m => m.VendasGraficoComparativoPageModule)
  },
  {
    path: 'vendas-lucratividade',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/vendas-lucratividade/vendas-lucratividade.module').then( m => m.VendasLucratividadePageModule)
  },
  {
    path: 'vendas-comparativo-indice',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/vendas-comparativo-indice/vendas-comparativo-indice.module').then( m => m.VendasComparativoIndicePageModule)
  },
  {
    path: 'vendas-liberar-desconto',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/vendas-liberar-desconto/vendas-liberar-desconto.module').then( m => m.VendasLiberarDescontoPageModule)
  },
  {
    path: 'cadastro-condicao-pagamento',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/cadastro-condicao-pagamento/cadastro-condicao-pagamento.module').then( m => m.CadastroCondicaoPagamentoPageModule)
  },
  {
    path: 'shopee',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/shopee/shopee.module').then( m => m.ShopeePageModule)
  },
  {
    path: 'vendedores-desempenho',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/vendedores-desempenho/vendedores-desempenho.module').then( m => m.VendedoresDesempenhoPageModule)
  },
  {
    path: 'vendedores-desempenho-detalhe',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/vendedores-desempenho-detalhe/vendedores-desempenho-detalhe.module').then( m => m.VendedoresDesempenhoDetalhePageModule)
  },
  {
    path: 'cadastro-vendedores',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/cadastro-vendedores/cadastro-vendedores.module').then( m => m.CadastroVendedoresPageModule)
  },
  {
    path: 'estoque-resumo',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/estoque-resumo/estoque-resumo.module').then( m => m.EstoqueResumoPageModule)
  },
  {
    path: 'estoque-curva-abc',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/estoque-curva-abc/estoque-curva-abc.module').then( m => m.EstoqueCurvaAbcPageModule)
  },
  {
    path: 'estoque-entradas',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/estoque-entradas/estoque-entradas.module').then( m => m.EstoqueEntradasPageModule)
  },
  {
    path: 'estoque-entradas-detalhe',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/estoque-entradas-detalhe/estoque-entradas-detalhe.module').then( m => m.EstoqueEntradasDetalhePageModule)
  },
  {
    path: 'estoque-tamanho',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/estoque-tamanho/estoque-tamanho.module').then( m => m.EstoqueTamanhoPageModule)
  },
  {
    path: 'estoque-vendido-fornecedor',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/estoque-vendido-fornecedor/estoque-vendido-fornecedor.module').then( m => m.EstoqueVendidoFornecedorPageModule)
  },
  {
    path: 'cadastro-alteracao-promocao',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/cadastro-alteracao-promocao/cadastro-alteracao-promocao.module').then( m => m.CadastroAlteracaoPromocaoPageModule)
  },
  {
    path: 'cadastro-alteracao-promocao-planilha',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/cadastro-alteracao-promocao-planilha/cadastro-alteracao-promocao-planilha.module').then( m => m.CadastroAlteracaoPromocaoPlanilhaPageModule)
  },
  {
    path: 'cadastro-produtos',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/cadastro-produtos/cadastro-produtos.module').then( m => m.CadastroProdutosPageModule)
  },
  {
    path: 'estoque-consultar',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/estoque-consultar/estoque-consultar.module').then( m => m.EstoqueConsultarPageModule)
  },
  {
    path: 'estoque-consultar-detalhe',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/estoque-consultar-detalhe/estoque-consultar-detalhe.module').then( m => m.EstoqueConsultarDetalhePageModule)
  },
  {
    path: 'financeiro-relatorio',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/financeiro-relatorio/financeiro-relatorio.module').then( m => m.FinanceiroRelatorioPageModule)
  },
  {
    path: 'financeiro-baixa-contas',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/financeiro-baixa-contas/financeiro-baixa-contas.module').then( m => m.FinanceiroBaixaContasPageModule)
  },
  {
    path: 'financeiro-fluxo-caixa',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/financeiro-fluxo-caixa/financeiro-fluxo-caixa.module').then( m => m.FinanceiroFluxoCaixaPageModule)
  },
  {
    path: 'financeiro-recebimento-parcelas',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/financeiro-recebimento-parcelas/financeiro-recebimento-parcelas.module').then( m => m.FinanceiroRecebimentoParcelasPageModule)
  },
  {
    path: 'cadastro-contas-pagar',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/cadastro-contas-pagar/cadastro-contas-pagar.module').then( m => m.CadastroContasPagarPageModule)
  },
  {
    path: 'clientes-melhores',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/clientes-melhores/clientes-melhores.module').then( m => m.ClientesMelhoresPageModule)
  },
  {
    path: 'clientes-fluxo',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/clientes-fluxo/clientes-fluxo.module').then( m => m.ClientesFluxoPageModule)
  },
  {
    path: 'clientes-qualidade',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/clientes-qualidade/clientes-qualidade.module').then( m => m.ClientesQualidadePageModule)
  },
  {
    path: 'ler-barras',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/ler-barras/ler-barras.module').then( m => m.LerBarrasPageModule)
  },
  {
    path: 'cadastrar-produtos-amc',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/cadastrar-produtos-amc/cadastrar-produtos-amc.module').then( m => m.CadastrarProdutosAmcPageModule)
  },
  {
    path: 'vendas-grafico-semanas',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/vendas-grafico-semanas/vendas-grafico-semanas.module').then( m => m.VendasGraficoSemanasPageModule)
  },
  {
    path: 'ml',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/mercadoLivre/ml/ml.module').then( m => m.MlPageModule)
  },
  {
    path: 'cadastrar-item-ml',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/mercadoLivre/cadastrar-item-ml/cadastrar-item-ml.module').then( m => m.CadastrarItemMlPageModule)
  },
  {
    path: 'marketplace-produtos',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/marketplace-produtos/marketplace-produtos.module').then( m => m.MarketplaceProdutosPageModule)
  },
  {
    path: 'marketplace-add',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/marketplace-add/marketplace-add.module').then( m => m.MarketplaceAddPageModule)
  },
  {
    path: 'marketplace-editar',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/marketplace-editar/marketplace-editar.module').then( m => m.MarketplaceEditarPageModule)
  },
  {
    path: 'cadastro-grupos',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/cadastro-grupos/cadastro-grupos.module').then( m => m.CadastroGruposPageModule)
  },
  {
    path: 'vendas-campanhas',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/vendas-campanhas/vendas-campanhas.module').then( m => m.VendasCampanhasPageModule)
  },
  {
    path: 'cadastro-manutencao-vendas',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/cadastro-manutencao-vendas/cadastro-manutencao-vendas.module').then( m => m.CadastroManutencaoVendasPageModule)
  },
  {
    path: 'avaliacao-vendedores',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/avaliacao-vendedores/avaliacao-vendedores.module').then( m => m.AvaliacaoVendedoresPageModule)
  },
  {
    path: 'comparativo-hora',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/comparativo-hora/comparativo-hora.module').then( m => m.ComparativoHoraPageModule)
  },
  {
    path: 'correios',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/correios/correios.module').then( m => m.CorreiosPageModule)
  },
  {
    path: 'pixstatus',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/pixstatus/pixstatus.module').then( m => m.PixstatusPageModule)
  },
  {
    path: 'retorno-remessa',
    canLoad: [CheckTutorial],
    loadChildren: () => import('./pages/retorno-remessa/retorno-remessa.module').then( m => m.RetornoRemessasPageModule)
  }

  //RetornoRemessa
 
];

@NgModule({
  imports: [RouterModule.forRoot(routes)],
  exports: [RouterModule]
})
export class AppRoutingModule {}
