import { NgModule } from '@angular/core';
import { HttpClientModule } from '@angular/common/http';
import { BrowserModule } from '@angular/platform-browser';
import { InAppBrowser } from '@ionic-native/in-app-browser/ngx';
import { SplashScreen } from '@ionic-native/splash-screen/ngx';

import { StatusBar } from '@ionic-native/status-bar/ngx';
import { IonicModule, IonicRouteStrategy, Platform } from '@ionic/angular';
import { IonicStorageModule } from '@ionic/storage';

import { AppRoutingModule } from './app-routing.module';
import { AppComponent } from './app.component';
import { ServiceWorkerModule } from '@angular/service-worker';
import { environment } from '../environments/environment';
import { FormsModule } from '@angular/forms';
import { SQLite } from '@ionic-native/sqlite/ngx';
import { ParametrosComponent } from './modal/parametros/parametros.component';
import { BarcodeScanner } from '@ionic-native/barcode-scanner/ngx';
import { TelaGenericaComponent } from './modal/tela-generica/tela-generica.component';
import { Camera } from '@ionic-native/camera/ngx';
import { ContaCorrenteBaixaComponent } from './modal/conta-corrente-baixa/conta-corrente-baixa.component';

import { ZXingScannerModule } from '@zxing/ngx-scanner';
import { LerBarrasComponent } from './modal/ler-barras/ler-barras.component';
import { TelaMercadolivreComponent } from './modal/tela-mercadolivre/tela-mercadolivre.component';
import { PesquisarProdutosComponent } from './modal/pesquisar-produtos/pesquisar-produtos.component';
import { SocialSharing } from '@ionic-native/social-sharing/ngx';

import { Network } from '@ionic-native/network/ngx';
import { FileOpener } from '@ionic-native/file-opener/ngx';
import { File } from '@ionic-native/file/ngx';
import { Printer } from '@ionic-native/printer/ngx';
import { AvaliacaoDetalheComponent } from './modal/avaliacao-detalhe/avaliacao-detalhe.component';
import { RouteReuseStrategy } from '@angular/router';

// import { SocketIoModule, SocketIoConfig } from 'ngx-socket-io';
// const config: SocketIoConfig = { url: 'http://localhost:3001', options: {} };


/*
import { ConverterDataPipe } from './pipes/converter-data.pipe';
import { ConverterTimestampPipe } from './pipes/converter-timestamp.pipe';
import { FormatarDinheiroPipe } from './pipes/formatar-dinheiro.pipe';
import { GroupByPipe } from './pipes/group-by.pipe';
import { GroupEstoquePipe } from './pipes/group-estoque.pipe';
import { StatusShopeePipe } from './pipes/status-shopee.pipe';
*/
@NgModule({
  imports: [    
    BrowserModule,
    AppRoutingModule,
    HttpClientModule,
    FormsModule,
    ZXingScannerModule,
    IonicModule.forRoot(),
    IonicStorageModule.forRoot(),
    // SocketIoModule.forRoot(config),
    ServiceWorkerModule.register('ngsw-worker.js', {
      enabled: environment.production
    })
  ],
  declarations: [AppComponent, ParametrosComponent, TelaGenericaComponent, ContaCorrenteBaixaComponent, 
    LerBarrasComponent, TelaMercadolivreComponent, PesquisarProdutosComponent, AvaliacaoDetalheComponent],
  entryComponents: [ParametrosComponent, TelaGenericaComponent, ContaCorrenteBaixaComponent, 
    LerBarrasComponent, TelaMercadolivreComponent, PesquisarProdutosComponent, AvaliacaoDetalheComponent],
  providers: [InAppBrowser, SplashScreen, StatusBar, SQLite, Platform,
    BarcodeScanner, Camera, SocialSharing, Network, File, FileOpener, Printer,
    { provide: RouteReuseStrategy, useClass: IonicRouteStrategy }
  ],
  bootstrap: [AppComponent],
  // exports: [ConverterDataPipe, ConverterTimestampPipe, FormatarDinheiroPipe, GroupByPipe, GroupEstoquePipe, StatusShopeePipe]
})
export class AppModule {}
