import { Component, OnInit } from '@angular/core';
import { ModalController } from '@ionic/angular';
import { ParametrosComponent } from '../../modal/parametros/parametros.component';
import { TelaGenericaComponent } from '../../modal/tela-generica/tela-generica.component';
import { AuthServiceService } from '../../providers/auth-service.service';
import { EstoqueLojasService } from '../../providers/estoque-lojas.service';
import { LoaderService } from '../../providers/loader.service';

@Component({
  selector: 'app-cadastro-produtos',
  templateUrl: './cadastro-produtos.page.html',
  styleUrls: ['./cadastro-produtos.page.scss'],
})
export class CadastroProdutosPage implements OnInit {
  artigo: any = "";
  marca: any = "";
  grupo: any = "";
  colecao: any = "";
  genero: any = "";
  fornecedor: any = "";
  referencia: any = "";
  cores: any = "";
  descricao: any = "";
  margem: any = "";
  custo: any = "";
  venda: any = "";
  tamanho: any;
  tamanhos: any =[];
  ncm: any = "";
  
  produto: any = {
    codprod: "",
    cod_artigo : "",
    cod_marca: "",
    grupo : "",
    colecaoid: "",
    dtecd: "",
    codforn: "",
    refe: "",
    cod_cor: [],
    descricao_cor: [],
    descr: "",
    lucro: "",
    medio: "",
    custo: "",
    venda: "",
    dtece: "A",
    codgrade: "",
    ncm: "",
    grade: [],
    id: ""
  }

  data = { 
    filtroArtigos : [],
    filtroGrupos : [],
    filtroMarcas : [],
    idConexao: '',
    loja: ''
  }
  constructor(public estoque: EstoqueLojasService, public modalController: ModalController,
    public loader: LoaderService, public auth: AuthServiceService) { }

  ngOnInit() {
    this.buscarCadastroTamanhos();  
  }

  openModal(){
    
  }


/*
  pesquisarProduto() {
    let popover = this.modalCtrl.create('ConsultarEstoquePage');
    popover.onDidDismiss(
        data => {
          if(data == undefined || data == 'undefined'){
            return;
          }
          // console.log(data);
          this.produto.codprod = data.CODPROD;
          this.produto.cod_artigo = data.COD_ARTIGO;
          this.produto.cod_marca = data.COD_MARCA;
          this.produto.grupo = data.GRUPO;
          this.produto.colecaoid = data.ID;
          this.produto.dtecd = data.GENERO;
          this.produto.codforn = data.CODFORN;
          this.produto.refe = data.REFERENCIA;
          this.produto.cod_cor = [{"cod_cor" : data.COD_COR, "descr" : data.DESCRICAO_COR}];//[],
          this.produto.descricao_cor = [{"cod_cor" : data.COD_COR, "descr" : data.DESCRICAO_COR}];// [],
          this.produto.descr = data.DESCRICAO;
          this.produto.lucro = data.LUCRO.toFixed(2);;
          this.produto.medio = data.CUSTO.toFixed(2);;
          this.produto.custo = data.CUSTO.toFixed(2);;
          this.produto.venda = data.VENDA;
          this.produto.codgrade = data.CODGRADE;
          this.produto.ncm = data.NCM;
          this.produto.grade = data.CODPROD;// [],

          this.custo = data.CUSTO.toFixed(2);;
          this.venda = data.VENDA.toFixed(2);;
          this.margem = data.LUCRO.toFixed(2);;
          this.descricao = data.DESCRICAO;
          this.referencia = data.REFERENCIA;
          this.genero = data.GERENERO;
          
          this.artigo = data.DESCRICAO_ARTIGO;
          this.marca = data.DESCRICAO_MARCA;
          this.grupo = data.DESCRICAO_GRUPO;
          this.colecao = data.DESCRICAO_COLECAO;
          this.fornecedor = data.DESCRICAO_FORNECEDOR;
          this.tamanho = data.DESCRICAO_GRADE;
          // this.tamanhos = data.DESCRICAO_GRADE;
          this.ncm = data.NCM;                          
          this.cores = data.DESCRICAO_COR;                            
        }
    );
    popover.present();
  }*/

  buscarCadastroTamanhos(){    
    this.estoque.buscarCadastroTamanho()
    .then((result: any) => {
      if(result.length == 0){
        this.tamanhos.push({
          "CODGRADE" : 0,
          "DESCR": "GRADE UNICA",
          "NUMERO_INI": 1,
          "NUMERO_FIM": 1,
          "NUMERO_PAR": "S",
          "NUMERO_IMPAR": "S"
        });        
      } else {
        this.tamanhos = result;        
      }
    })
    .catch((error: any) => {
      console.log('error: '+error);
    });
  }
  async abrirTelaGenerica(tela) {
    const modal = await this.modalController.create({
      component: TelaGenericaComponent,
      componentProps: {
        tela: tela, parametro: 'cadastrarProduto'
      },
      backdropDismiss: false,      
    });

    modal.onDidDismiss().then((res) => {      
      let data = res.data;
      if(data != null){
        //this.funcaoTela(data.TELA);
        if(data.TELA == "artigo"){
          this.artigo = data.DESCRICAO;
          this.produto.cod_artigo = data.CODIGO;
          return;
        }
        if(data.TELA == "marca"){
          this.marca = data.DESCRICAO;
          this.produto.cod_marca = data.CODIGO;
          return;
        }
        if(data.TELA == "grupo"){
          this.grupo = data.DESCRICAO;
          this.produto.grupo = data.CODIGO;
          return;
        }
        if(data.TELA == "colecao"){
          this.colecao = data.DESCRICAO;
          this.produto.colecaoid = data.CODIGO;
          return;
        }
        if(data.TELA == "fornecedores"){
          this.fornecedor = data.DESCRICAO;
          this.produto.codforn = data.CODIGO;
          return;
        }
        if(data.TELA == "tamanho"){
          this.tamanho = data.DESCRICAO;
          this.produto.codgrade = data.CODIGO;
          return;
        }
        if(data.TELA == "ncm"){
          this.ncm = data.CODIGO;            
          return;
        }
        if(data.length > 0){
          this.loader.presentToast("Não coloque a cor na descrição do produto, o sistema vai preencher no final automaticamente.");
          for (let i = 0; i < data.length; i++) {
            const element = data[i];
            this.cores = this.cores + ' / ' + element.DESCRICAO + ' \n ';
            this.produto.cod_cor.push({"cod_cor" : element.CODIGO, "descr" : element.DESCRICAO});
            this.produto.descricao_cor.push(element.DESCRICAO);
          }
        }
      }
    });
    return await modal.present();
  }
  
  salvarCadastro(){

    this.produto.grade = [];
    this.produto.tamanho = this.tamanho;
    this.produto.codgrade = this.tamanho;    
      for (let i = 0; i < this.tamanhos.length; i++) {
        const element = this.tamanhos[i];
        if(element.CODGRADE == this.produto.codgrade){
          for (let a = element.NUMERO_INI; a <= element.NUMERO_FIM; a++) {
            let par:boolean = element.NUMERO_PAR == 'S' ? true : false;
            let impar:boolean = element.NUMERO_IMPAR == 'S' ? true : false;
            if(par == true && impar == false && (a % 2 === 0)){
              this.produto.grade.push(a);
            }
            if(par == false && impar == true && (a % 2 !== 0)){
              this.produto.grade.push(a);
            }
            if(par == true && impar == true){            
              if(a >= 1000 ){
                this.produto.grade.push(this.tamanhoPMG(a));
              } else {
                this.produto.grade.push(a);
              }
            }
          }        
        }
      }
    
    if(this.ncm == "" || this.descricao == "" || this.referencia == "" || this.venda == "" ||
    this.custo == "" || this.margem == "" || this.produto.codforn == ""){
      this.loader.showError("Atenção!", "Preencha todos os campos com algum valor antes de finalizar.");
    } else if(this.produto.grade.length == 0){
      this.loader.showError("Atenção!", "Escolha algum tamanho antes de finalizar.");
    } else {
      this.produto.ncm = this.ncm;
      this.produto.descr = this.descricao;
      this.produto.refe = this.referencia;
      this.produto.dtecd = this.genero;      
      this.produto.custo = this.custo.replace(".",",");
      this.produto.medio = this.custo.replace(".",",");    
      this.produto.lucro = this.margem.replace(".",",");    
      this.produto.venda = this.venda.replace(".",",");
      this.produto.id = this.auth.Id;
      this.loader.showLoader("Cadastrando os produtos...");
      this.estoque.cadastrarProduto(this.produto)
      .then((result: any) => {        
        this.loader.hideLoader();
        
          if(result.length > 0){
            this.produto.codprod = "";
            this.produto.refe = "";
            this.referencia = "";
            this.produto.descr = "";
            this.descricao = "";
            this.produto.cod_cor = [];
            this.cores = "";
            let texto = "";
            for (let i = 0; i < result.length; i++) {
              const element = result[i];
              texto = texto + element.codprod + ' - ' + element.descr + '<br>'
            }          
            this.loader.showError('Itens cadastrados', texto);
          }
        
      })
      .catch((error: any) => {
        console.log('error: '+error);
      });
    }     
  }
  
  tamanhoPMG(tamanho){
    if(tamanho == 1000){
      return 'RN';        
    } else if(tamanho == 1001){
      return 'BB';
    } else if(tamanho == 1002){
      return 'PP';        
    } else if(tamanho == 1003){
      return 'P';
    } else if(tamanho == 1004){
      return 'M';        
    } else if(tamanho == 1005){
      return 'G';
    } else if(tamanho == 1006){
      return 'GG';
    } else if(tamanho == 1007){
      return 'EXG';
    }
  }
  

  campoReferencia(){
    this.produto.refe = this.referencia;
    this.descricao = this.grupo + " " + this.marca + " " + this.referencia;
    if(this.referencia != ""){
      this.loader.showLoader("Vou verificar se já existe essa referência, um instante...");
      this.estoque.buscarReferenciaFornecedor(this.referencia, this.produto.codforn)
      .then((result: any) => {      
        this.loader.hideLoader();
        
          if(result.length > 0){
            let texto = "";
            for (let i = 0; i < result.length; i++) {
              const element = result[i];
              texto = texto + element.CODPROD + ' - ' + element.DESCR + '<br>'
            }          
            this.loader.showError('Info: Encontrei esses cadastros...', texto);
          } else {
            this.loader.presentToast("Tudo certo! Pode terminar o cadastro...");
          }        
      })
      .catch((error: any) => {
        console.log('error: '+error);
      });
    }
  }

  calcularVenda(e){
    var valorCusto:number = parseFloat(e.srcElement.value.toString().replace(',','.'));    
    this.venda = ((1 + (parseFloat(this.margem.replace(".","").replace(",",".")) / 100) ) * valorCusto).toFixed(2);    
  }

  calcularLucro(e){    
    var valorVenda:number = parseFloat(e.srcElement.value.toString().replace(',','.'));    
    var valorCusto:number = parseFloat(this.custo.toString().replace(',','.'));        
    this.margem = (((valorVenda / valorCusto) - 1) * 100).toFixed(2);
  }

  procurarNCM(e){
    var ncm: string = e.srcElement.value.toString();
    if(ncm.length == 8){
      this.loader.showLoader("Consultando ncm...");
      this.estoque.buscarNCM(ncm)
      .then((result: any) => {
        this.loader.hideLoader();
        if(result.length == 0){
          this.loader.presentToast("Desculpe! Não encontrei esse NCM cadastrado no seu banco de dados...");
        } else {
          this.ncm = ncm;
        }                
      })
      .catch((error: any) => {
        this.loader.hideLoader();
        console.log('error: '+error);
      });
    }
  }
}
