import { Component, OnInit } from '@angular/core';
import { ActivatedRoute, Router } from '@angular/router';
import { EstoqueLojasService } from '../../providers/estoque-lojas.service';
import { LoaderService } from '../../providers/loader.service';

@Component({
  selector: 'app-estoque-entradas-detalhe',
  templateUrl: './estoque-entradas-detalhe.page.html',
  styleUrls: ['./estoque-entradas-detalhe.page.scss'],
})
export class EstoqueEntradasDetalhePage implements OnInit {
  public nome: '';
  public nota: '';
  parametro = {
    id : '',
    pedido: ''
  }
  estoque: any;
  mes: any;
  data: any;
  constructor(private route: ActivatedRoute, private router: Router, public loader: LoaderService,
    public estoqueP: EstoqueLojasService) {
      this.route.queryParams.subscribe(params => {        
        this.data = JSON.parse(params.special);                
        
        this.parametro.pedido = this.data['PEDIDO'];
        this.nome = this.data['NOME'];
        this.nota = this.data['NUMERO_NOTA'];
        this.buscarEntradasPedido(this.parametro);   
      });
     }

  ngOnInit() {}

  buscarEntradasPedido(parametro){    
    this.estoque = [];
    this.loader.showLoader("Buscando itens da entrada...");
    this.estoqueP.buscarEntradasPedido(parametro)
    .then((result: any) => {      
      this.estoque = result;
      this.loader.hideLoader();        
        if(result.length == 0){
          this.loader.presentToast("Não encontrei nada!")
        }        
      })
      .catch((error: any) => {
        this.loader.showError("Ops", error);        
      });
  }

}
