import { Component, OnInit } from '@angular/core';
import { ActivatedRoute, Router } from '@angular/router';
import { AlertController, ModalController } from '@ionic/angular';
import { ContaCorrenteBaixaComponent } from '../../modal/conta-corrente-baixa/conta-corrente-baixa.component';
import { FinanceiroLojasService } from '../../providers/financeiro-lojas.service';
import { LoaderService } from '../../providers/loader.service';

@Component({
  selector: 'app-financeiro-baixa-contas',
  templateUrl: './financeiro-baixa-contas.page.html',
  styleUrls: ['./financeiro-baixa-contas.page.scss'],
})
export class FinanceiroBaixaContasPage implements OnInit {
  financeiro : any;
  parametro: any;
  tipos: any = 'F';
  pagar: boolean = false;
  style: any;
  total: any = 0;
  baixaAutomatica: any = [];
  constructor(private route: ActivatedRoute,
    private router: Router, public loader: LoaderService, 
    public finances: FinanceiroLojasService,
    public alertController: AlertController, public modalController: ModalController) { 
    this.route.queryParams.subscribe(params => {        
      this.parametro = JSON.parse(params.special);        
      this.detalheFinanceiro(this.parametro);
    });
  }

  ngOnInit() {
    this.loader.presentToast("Clique no botão superior ao lado direito para marcar as contas que deseja baixar.");
  }


  pagarContas(){        
    this.pagar = true;  
    (this.baixaAutomatica == [])
  }

  updateCucumber(pedido, parcela, valor) {
    let t: boolean = false;    
    let b = {
      "PEDIDO": pedido,
      "PARCELA": parcela,
      "VALOR": valor
    }
    for (let i = 0; i < this.baixaAutomatica.length; i++) {
      const element = this.baixaAutomatica[i];
      if(element.PEDIDO == pedido && element.PARCELA == parcela){
        t = true;
        this.total = this.total - valor;
        this.baixaAutomatica.splice(i, 1);
      } 
    }
    if(t == false){
      this.total = this.total + valor;
      this.baixaAutomatica.push(b);
    }    
  }
  
  ionViewDidEnter(){
    this.clicou();
    this.tipos = 'F';
  }

  async baixarContas(){    
    if(this.total > 0){
      const modal = await this.modalController.create({
        component: ContaCorrenteBaixaComponent,
        componentProps: {data: this.baixaAutomatica},
        backdropDismiss: false,      
      });  
      modal.onDidDismiss().then((data: any) => {        
        if(data.data != undefined){
          for (let e = 0; e < data.data.length; e++) {
            const elemento = data.data[e];
            for (let i = 0; i < this.financeiro.length; i++) {
              const element = this.financeiro[i];                              
              if(element.PEDIDO == elemento.PEDIDO && element.PARCELA == elemento.PARCELA){                                    
                this.financeiro.splice(i, 1);
              }                 
            }            
          }
          this.baixaAutomatica = [];
          this.total = 0;
        }
      });  
      return await modal.present();      
    }
  }

  detalheFinanceiro(data){    
    this.financeiro = [];
    this.finances.financeiroLojasDetalhe(data)
    .then((result: any) => {
      this.financeiro = result;      
    })
    .catch((error: any) => {
      console.log('error: '+error);
    });
  }

  clicou(){
    console.log("clicou");
  }

}
