import { Component, ElementRef, OnInit, ViewChild } from '@angular/core';
import { Router } from '@angular/router';

import { UserData } from '../../providers/user-data';

import { UserOptions } from '../../interfaces/user-options';
import { AlertController, IonDatetime, LoadingController, ModalController, NavController, Platform } from '@ionic/angular';
import { AuthServiceService } from '../../providers/auth-service.service';
import { DbService } from '../../providers/db.service';
import { Storage } from '@ionic/storage';
import { LoaderService } from '../../providers/loader.service';
import { AppComponent } from '../../app.component';
import { InAppBrowser } from '@ionic-native/in-app-browser/ngx';
import { SocialSharing } from '@ionic-native/social-sharing/ngx';

// declare var Socket: any;

@Component({
  selector: 'page-login',
  templateUrl: 'login.html',
  styleUrls: ['./login.scss'],
})
export class LoginPage implements OnInit {
  
  @ViewChild('IonDatetime', { static: true }) datetime: IonDatetime;


  dateValue = '';
  dateValue2 = '';
  data1: any = '';
  login: UserOptions = { username: '', password: '' };
  submitted = false;

  title: any = '';
  errorMessage: any;

  public idd: any;
  
  plat: any;
  registerCredentials = { email: '', password: '' , id: '', nome: '', senha: '', tokenfcm: '', idTelefone: ''};  
  tipoCel: any;
  mobile: boolean = false;
  public lojaSelecionada: any;
  servidores: any = [];
  mobileweb: boolean = false;


  message = '';
  messages = [];
  currentUser = '';

  constructor(
    public userData: UserData,
    public router: Router,
    public nav: NavController, 
    public loadingCtrl: LoadingController, public alertCtrl: AlertController,
    public auth: AuthServiceService, public plt: Platform, public modalCtrl: ModalController,
    public db: DbService, 
    private storage: Storage, 
    public loader: LoaderService,
    public comp: AppComponent,
    public iab: InAppBrowser,
    public socialSharing: SocialSharing,
    // private socket: Socket
  ) { 
    
    this.plat = this.plt.platforms();    
    this.storage.get('ID').then((val) => {
      if(val != null){
        for (let i = 0; i < val.length; i++) {
          const element = val[i];
          this.registerCredentials.id = element.ID_;
          this.registerCredentials.nome = element.NOME;
          this.registerCredentials.senha = element.SENHA;        
        }
      }
    });
    
    this.tipoCel = 'core';
    for (let i = 0; i < this.plat.length; i++) {
      const element = this.plat[i];
      // alert(element);
      if(element == 'ios' || element == 'iphone'){
        this.tipoCel = 'ios';
      } 
      if(element == 'android'){
        this.tipoCel = 'android';
      }
      if(element == 'mobileweb'){
        this.mobileweb = true;
      }
      if(element == 'mobile' || element == 'cordova'){
        this.mobile = true;
      }      
    }
  }

  
  printGill(){
    /*const socket = new Socket();    
    let ComandoEnviar = "ESCPOS.imprimir(" + "</zera></ce></linha_dupla></lf>EAN 8: 1234567</lf><ean8>1234567</ean8></pular_linhas></corte_total>" + ")";      
    var data3 = ComandoEnviar.trim() + '\r' + '\n' + "." + '\r' + '\n';    
    var data2 = new Uint8Array(data3.length);
    for (var i = 0; i < data2.length; i++) {
      data2[i] = data3.charCodeAt(i);
    }
    socket.open(
      "127.0.0.1",
      3434,
      function(e) {
        console.log("Entrou aqui....");
        socket.onData = function(data) {
          socket.write(data2, function(e){
            if(e == "OK"){
              console.log("DEU CERTO!!!")
            }
            socket.close(function(sucess){
              console.log("Conexão fechada: "+sucess);
            }, function(error){
              console.log(error);
            });
          }, function(error){
            console.log(error);
          });
        };
      },
      (err) => {
        console.log(err);
      }
    ); 
    */
  }


  aqui(a){
    alert(a)
    console.log(this.datetime);
  }

  ionBlur(e){
    this.title = e;
    console.log('ionBlur');
    console.log(this.title);
  }

  ionFocus(e){
    this.title = e;
    console.log('ionFocus');
    console.log(this.title);
  }


  formatDates(e){
    this.data1 = e;
    console.log(e);
  }
  ngOnInit() {
    if(this.tipoCel == "android" && this.mobileweb == true){
      this.showConfirm('Baixar Business Inteligence na PlayStore?', 'https://play.google.com/store/apps/details?id=br.com.tecnodataonline.businessinteligence&hl=pt_BR');
    }
    if(this.tipoCel == "ios"){
      // this.showConfirm('Baixar Business Inteligence na Apple Store?', 'https://google.com.br');
      this.auth.modeloCelular = "ios";
    }
    if(this.mobile == true && this.mobileweb == false){
      this.auth.celular = true;
      // this.consultarServidor();    
    }
  }

  formatDate(e){
    console.log('Foi');
    console.log(e);
  }

  confirm() {
    
  }
  
  reset() {
    
  }

  consultarServidor(){
    this.db.consultarServidores().then((result: any) => {        
      if(result.length > 0){   
        this.servidores = result;     
      } 
    }, (error) => {
      console.log("ERROR: ", error);
    });
  }

  /*
  onLogin(form: NgForm) {
    this.submitted = true;

    if (form.valid) {
      this.userData.login(this.login.username);
      this.router.navigateByUrl('/app/tabs/schedule');
    }
  }
  */

  onSignup() {
    this.router.navigateByUrl('/signup');
  }

  whats(){
    this.socialSharing.shareViaWhatsAppToPhone('+556281888263', 'Message via WhatsApp', null, null).then((e) =>{
      console.log(e)
    }).catch((e) => {
      window.open("https://wa.me/556281888263?text=Olá, estou com dúvidas...", "_blank");
    });    
  }

  async showConfirm(menssage, link) {
    const alert = await this.alertCtrl.create({
      // cssClass: 'my-custom-class',
      header: 'Business Inteligence',
      // subHeader: 'Subtitle',
      message: menssage,
      buttons: [
        {
          text: 'Cancelar',
          role: 'cancel',
          cssClass: 'secondary',
          handler: (blah) => {
            console.log('Confirm Cancel: blah');
          }
        }, {
          text: 'Okay',
          handler: () => {
            //console.log('Confirm Okay');
            window.open(link, "_blank");
          }
        }
      ]
    });

    await alert.present();

    const { role } = await alert.onDidDismiss();
    console.log('onDidDismiss resolved with role', role);
  }

  ionViewDidEnter() {
    if(this.mobile == true && this.mobileweb == false){
      this.auth.celular = true;
      this.consultarServidor();    
    }
  }

  servidor(){
    // this.nav.setRoot('CadastrarServidorPage'); 
  }

  public logar() {    
    this.loader.showLoader("Consultando credenciais...");
    setTimeout(() => {
      this.loader.hideLoader();
    }, 10000);
    //this.router.navigateByUrl('/app/tabs/schedule');
    this.registerCredentials.tokenfcm = this.auth.tokenFCM;    
    this.registerCredentials.idTelefone = this.auth.device;      
    this.auth.login(this.registerCredentials)
      .then((result: any) => {
        // console.log(result);
        this.loader.hideLoader();                        
        if(result._body != ""){
          if(result.Status == "Não logado"){            
            this.loader.showError('Ops!', 'Não logado');            
          } else {
            
            this.userData.login(result.NOME);
            this.userData.setDataExpira();
            this.comp.nome = result.NOME;
            this.auth.fotoLoja = result.FOTOLOJA;
            this.comp.foto = result.FOTOLOJA;
            this.auth.logado = true;
            this.auth.Usuario.codigo = result.CODIGO;
            this.auth.Usuario.descvenda = parseFloat(result.DESCVENDA) ;
            this.auth.Usuario.gerente = result.GERENTE;
            this.auth.Usuario.loja = result.LOJA;
            this.auth.Usuario.nome = result.NOME;
            this.auth.Usuario.vendedor = result.VENDEDOR;
            this.auth.Usuario.ativoSistema = result.LICENCA.entrarSistema;
            this.auth.Usuario.ativoWhatsapp = result.LICENCA.entrarWhatsApp;
            this.auth.Id = result.ID;
            this.auth.Usuario.CNPJ = result.CNPJLOJA;            
            this.auth.shopee = (result.SHOPEE.partinerKey != '' ? true : false);
            this.auth.mercadoLivre = (result.MERCADOLIVRE.access_token != '' ? true : false);
            this.auth.nuvemShop = (result.NUVEMSHOP.autenticacao != '' ? true : false);
            this.auth.woocomerce = (result.WOOCOMMERCE.ck != '' ? true : false);
            this.auth.pluggto = (result.PLUGGTO.clientID != '' ? true : false);
            
            let ar: any = [];
            ar.push({
              "ID": this.auth.Id,
              "NOME": result.NOME,
              "SENHA": this.registerCredentials.senha, 
              "CODIGO": result.CODIGO,
              "LOJA": result.LOJA,
              "ID_": this.registerCredentials.id,
              "PERMISSOES": result.PERMISSOES
            });
            for (let i = 0; i < result.PERMISSOES.length; i++) {
              const element = result.PERMISSOES[i];
              if(element.MODULO == 'Mobile_NaoAcessarBI' && element.ENTRAR == 'true'){
                this.auth.logado = false;
              }
              if(element.MODULO == 'ResumodoDiaPorOperador' && element.ENTRAR == 'true'){
                this.auth.Usuario.somenteLojaLocal = true;
              }
            }
            this.storage.set("ID", ar);
            // this.storage.set("mudancas", "Agora com seu iOS você consegue adicionar fotos aos produtos. Vai em Estoque > Consultar estoque individual, pequisa o produto e clica sobre a imagem! ;D");
            
              if(this.auth.logado == false){                
                this.loader.showError('Ops', 'Seu usuário não esta habilitado p/ usar o APP.');
              } else {
                if(this.mobile == true && this.mobileweb == false){                  
                  this.db.insertUsuario(result.CODIGO, result.NOME, this.registerCredentials.senha, parseFloat(result.DESCVENDA), result.LOJA, result.VENDEDOR, this.registerCredentials.id);                    
                  this.router.navigateByUrl('/app/tabs/schedule');
                } else {                
                  this.router.navigateByUrl('/app/tabs/schedule');
                }
              }            
          }          
        }
        
      })
      .catch((error: any) => {
        this.loader.hideLoader();
        console.log(error);
        //this.toast.create({ message: 'Erro ao efetuar login. Erro: ' + error.error, position: 'botton', duration: 3000 }).present();        
      });
  }

  atualizarV(){
    this.comp.atualizar();
    // this.db.prepareDatabase();
  }

  mcqAnswer(){
    this.registerCredentials.nome = "";
    this.registerCredentials.senha = "";
    this.registerCredentials.id = this.lojaSelecionada;    
    this.db.getUsuarios(this.lojaSelecionada).then((result: any) => {
      if(result.length > 0){
        // this.servidores = result;     
        for (let i = 0; i < result.length; i++) {
          const element = result[i];          
          this.registerCredentials.id = this.lojaSelecionada;
          this.registerCredentials.nome = element.nome;
          this.registerCredentials.senha = element.senha;
        }
      } 
    }, (error) => {
      console.log("ERROR: ", error);
    });    
  }

  
}
