import { Component, OnInit } from '@angular/core';
import { ConferenceData } from '../../providers/conference-data';
import { Platform } from '@ionic/angular';

import { darkStyle } from './map-dark-style';
import { Storage } from '@ionic/storage';
import { AuthServiceService } from '../../providers/auth-service.service';

@Component({
  selector: 'page-map',
  templateUrl: 'map.html',
  styleUrls: ['./map.scss']
})
export class MapPage implements OnInit {  
  estoque : any;  
  codigo: any = '';
  data = { 
    filtroArtigos : [],
    filtroGrupos : [],
    filtroMarcas : [],
    idConexao: '',
    loja: ''
  }
  relResumoEstoque: boolean = true;
  amc: boolean = false;
  entradaDeProdutos: boolean = true;
  gruposMaisVendidos: boolean = true;
  relABC: boolean = true;
  relEstoquePorTamanho: boolean = true;
  cadProdutos: boolean = true;
  alteracaoModeloPlanilha: boolean = true;
  cadDeProdutos: boolean = true;
  usuario: any;
  registerCredentials = { id: '' };
  constructor(public platform: Platform,
    private storage: Storage, public auth: AuthServiceService) {
    
  }

  ngOnInit() {
    this.storage.get('ID').then((val) => {
      if(val != null){
        for (let i = 0; i < val.length; i++) {
          const element = val[i];
          this.registerCredentials.id = element.ID;
          this.usuario = element.NOME;            
          for (let a = 0; a < element.PERMISSOES.length; a++) {
            const elemento = element.PERMISSOES[a];
            if(elemento.MODULO == "RelatResumoDeTotaisDeEstoque" && elemento.ENTRAR == "true"){
              this.relResumoEstoque = false;
            }
            if(elemento.MODULO == "frmEntradaDeProdutos" && elemento.ENTRAR == "true"){
              this.entradaDeProdutos = false;
            }
            if(elemento.MODULO == "VendasCurvaABC" && elemento.ENTRAR == "true"){
              this.relABC = false;
            }
            if(elemento.MODULO == "VendasCurvaABC" && elemento.ENTRAR == "true"){
              this.relEstoquePorTamanho = false;
            }
            if(elemento.MODULO == "frmCadastroDeProdutos" && elemento.ENTRAR == "true"){
              this.cadProdutos = false;
              this.alteracaoModeloPlanilha = false;              
            }
            if(elemento.MODULO == "frmCadastroDeProdutos" && elemento.ENTRAR == "true" && elemento.INCLUIR == "true"){              
              this.cadDeProdutos = false;
            }
            if(elemento.MODULO == "relatProdutosMaisVendidosPorFornecedor" && (elemento.ENTRAR == "true" || elemento.ENTRAR == "S") ){              
              this.gruposMaisVendidos = false;
            }
          }
          // console.log(element.PERMISSOES['MODULO']);
        }
      } else {
        this.usuario = this.auth.Usuario.nome;
      }
    });
  }
}

