import { Component, ElementRef, OnInit, ViewChild } from '@angular/core';

import { from } from 'rxjs';
import { groupBy, mergeMap, toArray } from 'rxjs/operators';


import { ActivatedRoute, Router } from '@angular/router';
import { AlertController, ModalController } from '@ionic/angular';
import { PesquisarProdutosComponent } from '../../modal/pesquisar-produtos/pesquisar-produtos.component';
import { AuthServiceService } from '../../providers/auth-service.service';
import { EstoqueLojasService } from '../../providers/estoque-lojas.service';
import { LoaderService } from '../../providers/loader.service';

@Component({
  selector: 'app-marketplace-add',
  templateUrl: './marketplace-add.page.html',
  styleUrls: ['./marketplace-add.page.scss'],
})
export class MarketplaceAddPage implements OnInit {
  url: any = "";
  @ViewChild('pwaphoto1', { static: true }) pwaphoto1: ElementRef;
  @ViewChild('pwaphoto2', { static: true }) pwaphoto2: ElementRef;
  @ViewChild('pwaphoto3', { static: true }) pwaphoto3: ElementRef;
  @ViewChild('pwaphoto4', { static: true }) pwaphoto4: ElementRef;
  @ViewChild('pwaphoto5', { static: true }) pwaphoto5: ElementRef;

  variacoes: boolean = false;

  desabilitarBotao: boolean = false;
  foto1: any = "assets/imgs/semImagem.jpg";
  foto2: any = "assets/imgs/semImagem.jpg";
  foto3: any = "assets/imgs/semImagem.jpg";
  foto4: any = "assets/imgs/semImagem.jpg";
  foto5: any = "assets/imgs/semImagem.jpg";

  ngFoto1: any = "";
  ngFoto2: any = "";
  ngFoto3: any = "";
  ngFoto4: any = "";
  ngFoto5: any = "";

  produtosVariacoes: any = [];
  adicionado: boolean = false;
  produtoPai: any = "";
  descricao: any = "";
  descricaoCompleta: any = "";
  variacoesV: any = "";
  altura: any = "10";
  largura: any = "10";
  comprimento: any = "10";
  tamanho: any = "";
  peso: any = "0.5";
  
  sku: any = '';

  evento: Event;

  escolheuAtributos: boolean = false;
    
  public ParametroPai = {
    produtoPai : '',
    variacoes : [

    ]
  }
  
  public Parametro = {
    "id": "",
    "nomeTabela": "ECOMMERCE_PRODPAI",
    "valorChave": "1",
    "foto": "",
    "idGen": ""
  } 
  constructor(public rel_estoque: EstoqueLojasService, public auth: AuthServiceService, 
    public loader: LoaderService, public modalController: ModalController, 
    public router: Router, public alertController: AlertController, public route: ActivatedRoute) {
      this.route.queryParams.subscribe(params => {
        let parametro = JSON.parse(params.codigoPai);
        
        this.consultarItemEcommerceNovo(parametro);
        this.produtoPai = parametro;
        // this.nomeVendedor = params.
        // this.data = JSON.parse(params.special);        
        // this.buscarDesempenhoLojas(this.data);
      });
    }

  ngOnInit() {
    this.buscarVariacoes();
  }

  escolherFoto(foto, event){
    if(foto == 'foto1'){
      this.pwaphoto1.nativeElement.click();
    }
    if(foto == 'foto2'){
      this.pwaphoto2.nativeElement.click();
    }
    if(foto == 'foto3'){
      this.pwaphoto3.nativeElement.click();
    }
    if(foto == 'foto4'){
      this.pwaphoto4.nativeElement.click();
    }
    if(foto == 'foto5'){
      this.pwaphoto5.nativeElement.click();
    }
  }

  uploadPWA(e) {
    var fileList: FileList = null;
    if(e == 'foto1'){
      if (this.pwaphoto1 == null) {
        return;
      }
      fileList = this.pwaphoto1.nativeElement.files
    }
    if(e == 'foto2'){
      if (this.pwaphoto2 == null) {
        return;
      }
      fileList = this.pwaphoto2.nativeElement.files
    }
    if(e == 'foto3'){
      if (this.pwaphoto3 == null) {
        return;
      }
      fileList = this.pwaphoto3.nativeElement.files
    }
    if(e == 'foto4'){
      if (this.pwaphoto4 == null) {
        return;
      }
      fileList = this.pwaphoto4.nativeElement.files
    }
    if(e == 'foto5'){
      if (this.pwaphoto5 == null) {
        return;
      }
      fileList = this.pwaphoto5.nativeElement.files
    }
     
    if (fileList && fileList.length > 0) {
      this.resizeImage(fileList[0], 800, 800).then((resultado) => {   
        // console.log(resultado);
        if(e == 'foto1'){
          this.foto1 = resultado;   
        }
        if(e == 'foto2'){
          this.foto2 = resultado;   
        }
        if(e == 'foto3'){
          this.foto3 = resultado;   
        }
        if(e == 'foto4'){
          this.foto4 = resultado;   
        }
        if(e == 'foto5'){
          this.foto5 = resultado;   
        }
        this.enviarImgServer(e, resultado);
        /*
        this.Parametro.foto = resultado;
        this.Parametro.id = this.auth.Id;
        this.Parametro.codprod = this.codprod;
        this.enviarImgServer();      
        */  
      });
    }
  }

  resizeImage(file:File, maxWidth:number, maxHeight:number):Promise<any> {
    return new Promise((resolve, reject) => {
        let image = new Image();
        image.src = URL.createObjectURL(file);
        image.onload = () => {
            let width = image.width;
            let height = image.height;

            let newWidth;
            let newHeight;
						let canvas = document.createElement('canvas');
            
            if (width <= maxWidth && height <= maxHeight) {
            		canvas.width = width;
            		canvas.height = height;
                let context2 = canvas.getContext('2d');
            		context2.drawImage(image, 0, 0, width, height);						       		                
                resolve((""+canvas.toDataURL('image/jpeg')));
            } else {
              if (width > height) {
                  newHeight = height * (maxWidth / width);
                  newWidth = maxWidth;
              } else {
                  newWidth = width * (maxHeight / height);
                  newHeight = maxHeight;
              }
              
              canvas.width = newWidth;
              canvas.height = newHeight;
  
              let context = canvas.getContext('2d');
  
              context.drawImage(image, 0, 0, newWidth, newHeight);
  
              // canvas.toBlob(resolve, file.type);
              resolve(""+canvas.toDataURL('image/jpeg'));
            }                       
        };
        image.onerror = reject;
    });
  }

  enviarImgServer(e, foto){
    this.Parametro.id = this.auth.Id;
    this.Parametro.nomeTabela = 'ECOMMERCE_PRODPAI';
    this.Parametro.valorChave = this.produtoPai;
    this.Parametro.foto = foto;
    if(e == 'foto1'){
      this.Parametro.idGen = this.ngFoto1;
    }
    if(e == 'foto2'){
      this.Parametro.idGen = this.ngFoto2;
    }
    if(e == 'foto3'){
      this.Parametro.idGen = this.ngFoto3;
    }
    if(e == 'foto4'){
      this.Parametro.idGen = this.ngFoto4;
    }
    if(e == 'foto5'){
      this.Parametro.idGen = this.ngFoto5;
    }
    this.loader.showLoader("Enviando foto para o servidor...");
    
    this.rel_estoque.inserirFotoAleatoriaNovo(this.Parametro).then((resultado: any) => {
    
      this.loader.hideLoader();
      // this.loader.presentToast('Foto inserida com sucesso!');
      if(e == 'foto1'){
        this.ngFoto1 = resultado;
      }
      if(e == 'foto2'){
        this.ngFoto2 = resultado;
      }
      if(e == 'foto3'){
        this.ngFoto3 = resultado;
      }
      if(e == 'foto4'){
        this.ngFoto4 = resultado;
      }
      if(e == 'foto5'){
        this.ngFoto5 = resultado;
      }
    }).catch((error: any) => {
      this.loader.hideLoader();
        //console.log('error: '+error);
      this.loader.showError('Ops', 'O seu servidor pode estar sem internet no momento, tente novamente mais tarde.');
    });
  }


  public cadastrarCodigoPai(){
    this.loader.showLoader('Inserindo produto...');
    // inserirEcommercePAI($ID, $descricaoSimples, $descricaoCompleta, $comprimento, $altura, $largura, $status)
    this.rel_estoque.inserirEcommercePai(this.descricao, this.descricaoCompleta, this.sku, this.ParametroPai.variacoes, this.comprimento, this.largura, this.altura).then((result: any) => {
      // console.log(result);
      this.adicionado = true;
      this.loader.hideLoader();      
      this.produtoPai = result;
      // this.pesquisarProduto();
    }).catch((error: any) => {
      console.log(error);
      this.loader.hideLoader();
        //console.log('error: '+error);
      this.loader.showError('Ops', 'O seu servidor pode estar sem internet no momento, tente novamente mais tarde.');
    });
  }

  async addVariacoes(){
    const modal = await this.modalController.create({
      component: PesquisarProdutosComponent,
      componentProps: {        
      },
      backdropDismiss: false,      
    });
    modal.onDidDismiss().then((res) => {
      // console.log(res);
      for (let i = 0; i < res.data.length; i++) {
        const element = res.data[i];
        // this.addItem(element.codprod);
        for (let a = 0; a < this.produtosVariacoes.length; a++) {
          const elemento = this.produtosVariacoes[a];
          if(elemento.CODPROD == element.codprod.CODPROD){
            this.produtosVariacoes.splice(a, 1);
          }          
        }
        this.produtosVariacoes.push(element.codprod);
      }
    });
    return await modal.present();
  }

  cadastrarProduto(){
    this.loader.showLoader("Cadastrando variações...");    
    return this.rel_estoque.inserirEcommerceProd01(this.produtoPai, '', '', this.produtosVariacoes).then((result: any) => {
      this.loader.hideLoader();
      this.loader.presentToast('Variações inseridas com sucesso!');
      this.variacoesV = true;
      return result;
    }).catch((error: any) => {          
      this.loader.hideLoader();                
      console.log(error);
      this.loader.showError('Ops', 'O seu servidor pode estar sem internet no momento, tente novamente mais tarde.');
    });      
    
  }

  valorEscolhido(a,b){
    this.escolheuAtributos = true;
    this.ParametroPai.variacoes.push({
      'id': a.detail.value
    });
  }


  buscarVariacoes(){
    let ar = {
      "idConexao": this.auth.Id,      
      "tipo_ecommerce":"1"
    }
    return this.rel_estoque.buscarVariacoes(ar)      
    .then((result: any) => {      
      this.variacoes = result;
      this.loader.hideLoader();
    }).catch((error: any) => {          
      this.loader.hideLoader();                
      this.loader.showError('Ops', 'O seu servidor pode esta sem internet no momento, tente novamente mais tarde.');
    });      
  }

  async cadastrarProduto2(){
    for (const [idx, item] of this.produtosVariacoes.entries()) {
      // const todo = await this.addItem(item);
      if(this.produtosVariacoes.length == idx+1){
        // this.presentAlert();
        this.desabilitarBotao = true;
      }
    }     
  }

  async voltar(){
    if(this.variacoesV == false && this.ngFoto1 == ''){
      const alert = await this.alertController.create({
        cssClass: 'my-custom-class',
        header: 'Atenção!',
        message: 'Você não finalizou o cadastro, quer sair assim mesmo?',
        buttons: [
          {
            text: 'Não',
            role: 'cancel',
            cssClass: 'secondary',
            id: 'cancel-button',
            handler: (blah) => {
              console.log('Confirm Cancel: blah');
            }
          }, {
            text: 'Sim',
            id: 'confirm-button',
            handler: () => {
              this.router.navigateByUrl('/app/tabs/schedule/marketplace');
            }
          }
        ]
      });
  
      await alert.present();
      // this.loader.showError('Atenção', 'Escolhe as variações e fotos antes de sair da tela.');
    } else {
      this.inserirItemEcommerceNovo();
    }
  }

  inserirItemEcommerceNovo(){
    this.loader.showLoader('Aguarde... Inserindo produto no site.');
    return this.rel_estoque.inserirItemEcommerceNovo(this.produtoPai).then((result: any) => {
      // console.log(result);
      this.loader.hideLoader();
      // this.modalController.dismiss();
      this.router.navigateByUrl('/app/tabs/schedule/marketplace');
    }).catch((error: any) => {          
      this.loader.hideLoader();                
      this.loader.showError('Ops', 'O seu servidor pode estar sem internet no momento, tente novamente mais tarde.');
    });      
  }

  consultarItemEcommerceNovo(id){
    /*
    this.loader.showLoader('Aguarde... Consultando produto no site.');
    return this.rel_estoque.consultarItemEcommerceNovo(id).then((result: any) => {
      console.log(result);
      if(result.length > 0){
        let prodPai = result[0];
        this.descricao = prodPai[0]['DESCRICAO_SIMPLES'];
        this.descricaoCompleta = prodPai[0]['DESCRICAO_COMPLETA'];
        
        this.altura = prodPai[0]['ALTURA'];
        this.largura = prodPai[0]['LARGURA'];
        this.comprimento = prodPai[0]['COMPRIMENTO'];

        this.escolheuAtributos = true;
        this.adicionado = true;

        let variacoes = result[1];
        let teste = [];
        for (let a = 0; a < variacoes.length; a++) {
          const element = variacoes[a];
          teste.push({
            "CODPROD" : element.CODPROD,
            "REFERENCIA": element.REFERENCIA,
            "DESCRICAO": element.DESCRICA,
            "DESCRICAO_COR": element.DESCRICAO_COR,
            "VENDA": element.VENDA
          });
        }
        let result = teste. groupBy( CODPROD => CODPROD );
        this.produtosVariacoes = murilo;
        let fotos = result[2];
        for (let i = 0; i < fotos.length; i++) {
          const element = fotos[i];
          
        }
        let fotosSecundarias = result[3];
        let atributos = result[4];
      }
    }).catch((error: any) => {          
      this.loader.hideLoader();                
      this.loader.showError('Ops', 'O seu servidor pode estar sem internet no momento, tente novamente mais tarde.');
    });  
    */    
  }

  async presentAlert() {
    const alert = await this.alertController.create({
      cssClass: 'my-custom-class',
      header: 'Atenção',      
      message: 'Vou enviar os produtos p/ os sites.',
      buttons: [
        {
          text: 'Okay',
          id: 'confirm-button',
          handler: () => {
            this.inserirItemEcommerceNovo();
          }
        }
      ]
    });

    await alert.present();

    const { role } = await alert.onDidDismiss();
    console.log('onDidDismiss resolved with role', role);
  }

}
