import { Component, OnInit } from '@angular/core';
import { NavigationExtras, Router } from '@angular/router';
import { ActionSheetController } from '@ionic/angular';
import { EstoqueLojasService } from '../../providers/estoque-lojas.service';
import { LoaderService } from '../../providers/loader.service';

@Component({
  selector: 'app-marketplace-produtos',
  templateUrl: './marketplace-produtos.page.html',
  styleUrls: ['./marketplace-produtos.page.scss'],
})
export class MarketplaceProdutosPage implements OnInit {
  estoqueProduto: any;
  slideOpts = {
    initialSlide: 1,
    speed: 400
  };
  constructor(public actionSheetController: ActionSheetController, public loader: LoaderService,
    public estoque: EstoqueLojasService, public router: Router) { 
    }
    
    ngOnInit() {
      
    }
    
    ionViewDidEnter(){
      this.buscarProdutos();      
    }

  detalhe(e){
    /*
    let navigationExtras: NavigationExtras = {
      queryParams: {
        codigoPai: JSON.stringify(e.CODPAI)
      }
    };
    this.router.navigate(['/app/tabs/schedule/marketplace-add'], navigationExtras);
    */
  }

  
  async openModal(ev: any){
    const actionSheet = await this.actionSheetController.create({
      header: 'Albums',
      cssClass: 'my-custom-class',
      buttons: [/*{
        text: 'Delete',
        role: 'destructive',
        icon: 'trash',
        handler: () => {
          console.log('Delete clicked');
        }
      },*/ {
        text: 'Novo produto',
        icon: 'share',
        handler: () => {
          this.router.navigateByUrl('/app/tabs/schedule/marketplace-add');
          console.log('Share clicked');
        }
      }, /*{
        text: 'Play (open modal)',
        icon: 'caret-forward-circle',
        handler: () => {
          console.log('Play clicked');
        }
      }, {
        text: 'Favorite',
        icon: 'heart',
        handler: () => {
          console.log('Favorite clicked');
        }
      }, */{
        text: 'Cancelar',
        icon: 'close',
        role: 'cancel',
        handler: () => {
          console.log('Cancel clicked');
        }
      }]
    });
    await actionSheet.present();

    const { role } = await actionSheet.onDidDismiss();
    console.log('onDidDismiss resolved with role', role);
  }

  buscarProdutos(){
    this.loader.showLoader("Buscando produtos...");
    let idPai;
    this.estoqueProduto = "";
    this.estoque.buscarProdutoNovoEcommerce(idPai)
    .then((result: any) => {
      this.estoqueProduto = result;
      this.loader.hideLoader();      
    })
    .catch((error: any) => {      
      this.loader.hideLoader();
      this.loader.showError("Ops", error);
      
    });
  }

}
