import { Component, ElementRef, OnInit, ViewChild } from '@angular/core';
import { ActivatedRoute, Router } from '@angular/router';
import { AlertController, ModalController } from '@ionic/angular';
import { TelaMercadolivreComponent } from '../../../modal/tela-mercadolivre/tela-mercadolivre.component';
import { AuthServiceService } from '../../../providers/auth-service.service';
import { EstoqueLojasService } from '../../../providers/estoque-lojas.service';
import { LoaderService } from '../../../providers/loader.service';
import { MercadoLivreService } from '../../../providers/mercado-livre.service';

@Component({
  selector: 'app-cadastrar-item-ml',
  templateUrl: './cadastrar-item-ml.page.html',
  styleUrls: ['./cadastrar-item-ml.page.scss'],
})
export class CadastrarItemMlPage implements OnInit {
  url: any = "";
  
  tamanhos: any = [];
  tamanhosML: any = [];
  categorias: any [];
  produtoPai: any = "";
  categoriaEscolhida: any = "";
  listaCategoriasEscolhidas: any = [];
  atributos: any = [];
  atributoSelecionadoTela: any= "";
  sku: any = '';
  codBarra: any = '';
  public Params: any;
  public Parametro = {
    "id": "",
    "nomeTabela": "ECOMMERCE_PRODPAI",
    "valorChave": "1",
    "foto": ""
  }  
  att: any = [];  
  produto: any = {
    title: "",
    category_id:"",
    price:0,
    currency_id:"BRL",
    available_quantity:0,
    buying_mode:"buy_it_now",
    condition:"new",
    listing_type_id:"gold_special",
    sale_terms:[],
    // variations:[],
    pictures:[
       /*{foto1: ""},
       {foto2: ""},
       {foto3: ""},
       {foto4: ""},
       {foto5: ""}      
       */ 
    ],
    shipping: {
      mode: "me2",         	
      tags: ["mandatory_free_shipping","optional_me2_chosen"]
    },  
    attributes:[]
  }
  constructor(public ml: MercadoLivreService, public loader: LoaderService, 
    public alertController: AlertController, public modalController: ModalController,
    public rel_estoque: EstoqueLojasService, public auth: AuthServiceService,
    private route: ActivatedRoute, private router: Router) { 
      this.route.queryParams.subscribe(params => {
        this.Params = JSON.parse(params.codigoPai);
        console.log(this.Params);
        this.produto.title = this.Params.DESCRICAO_SIMPLES;
        for (let i = 0; i < this.Params.VARIACOES.length; i++) {
          const element = this.Params.VARIACOES[i];
          if(element.ECOMMERCE == 'MercadoLivre'){
            this.produto.price = element.VENDA;
            this.sku = element.CODPROD;
          }
        }
      });
    }
  
  ngOnInit() {
    this.url = '/sites/MLB/categories';
    // this.ml.Parametro.url = this.url;
    this.buscarCategorias(this.url);
  }

  buscarCategorias(url){
    // console.log(url);
    this.ml.categorias(url).then((result: any) => {      
      this.loader.hideLoader();
      this.categorias = [];
      if(result.children_categories){
        this.abrirTelaCategorias(result.children_categories, 'categorias');
      } else {
        this.abrirTelaCategorias(result, 'categorias');
      }
    }).catch((error: any) => {
      this.loader.hideLoader();
    });
  }

  async abrirTelaCategorias(categorias, parametro) {
    // console.log(categorias);
    if(categorias.length > 0){
      const modal = await this.modalController.create({
        component: TelaMercadolivreComponent,
        componentProps: {"categorias" : categorias,
      "parametro": parametro},
        backdropDismiss: false,      
      });
  
      modal.onDidDismiss().then((res) => {
        // console.log(res.data);
        if (res.data.valorEscolhido) {
          this.listaCategoriasEscolhidas.push(res.data.valorEscolhido)
          this.url = '/categories/'+res.data.valorEscolhido.id;
          this.categoriaEscolhida = res.data.valorEscolhido.id;
          this.produto.category_id = res.data.valorEscolhido.id;
          this.buscarCategorias(this.url);
        }
      });
      return await modal.present();
    } else {
      this.buscarAtributos('/categories/'+this.categoriaEscolhida+'/attributes');
    }
  }

  buscarAtributos(url){    
    this.ml.categorias(url).then((result: any) => {      
      this.loader.hideLoader();
      this.atributos = [];
      for (let i = 0; i < result.length; i++) {
        const element = result[i];
        if(element.relevance == 1){          
          this.atributos.push(element);
        }
      }
      console.log(this.atributos);      
    }).catch((error: any) => {
      this.loader.hideLoader();
    });
  }

  atributoSelecionado(att){
    this.valAtributoSelecionado(att);
  }

  async valAtributoSelecionado(att){
    console.log(att);
    let atrib = 'atributos';
    if(att == 'descricao'){
      atrib = 'descricao';
    }
    if(att.id == "SIZE"){
      this.tamanhosML = att.values;      
    }
    const modal = await this.modalController.create({
      component: TelaMercadolivreComponent,
        componentProps: {"categorias" : att,
        "parametro": atrib},
        backdropDismiss: false,      
    });
    modal.onDidDismiss().then((res) => {
      if(res.data.parametro == 'descricao'){
        this.produto.title = res.data.valorEscolhido.name;
        this.cadastrarCodigoPai();
      } else {
        if(res.data.valorEscolhido.id == 'SELLER_SKU' || res.data.valorEscolhido.id == 'SKU'){
          this.sku = res.data.valorEscolhido.name;
          this.consultarEstoque('codigo_winsae', res.data.valorEscolhido.name);          
        }
        if(res.data.valorEscolhido.id == 'GTIN'){
          // this.sku = res.data.valorEscolhido.name;
          this.consultarEstoque('ean', res.data.valorEscolhido.name);          
        }
        if(res.data.valorEscolhido.id != 'GTIN' && (res.data.valorEscolhido.id != 'SELLER_SKU' || res.data.valorEscolhido.id != 'SKU')){
          this.validarInfo(res);
        }
      }
      // console.log(this.produto);
    });
    return await modal.present();
    /*
    if(att.values){
      this.abrirTelaCategorias(att, 'atributos');
    }
    */
  }

  validarInfo(res){
    // console.log(res.data.valorEscolhido);
    for (let a = 0; a < this.produto.attributes.length; a++) {
      const element = this.produto.attributes[a];          
      if(element.id == res.data.valorEscolhido.id){
        this.produto.attributes.splice(a, 1);
      }
    }
    this.produto.attributes.push({
      "id": res.data.valorEscolhido.id,
      "name": (res.data.valorEscolhido.value_id == res.data.valorEscolhido.id) ? '' : res.data.valorEscolhido.name,
      "value_id": (res.data.valorEscolhido.value_id == res.data.valorEscolhido.id) ? '' : res.data.valorEscolhido.value_id,
      "value_name": res.data.valorEscolhido.name
    });        
    for (let i = 0; i < this.atributos.length; i++) {
      const element = this.atributos[i];          
      console.log(element);
      if(element.id == res.data.valorEscolhido.id){
        element.value_type = res.data.valorEscolhido.name;
      }
    }
  }

  async cancelarCategoria(item) {
    const alert = await this.alertController.create({
      cssClass: 'my-custom-class',
      header: 'Confirma a exclusão?',
      message: item.name,
      buttons: [
        {
          text: 'Não',
          role: 'cancel',
          cssClass: 'secondary',
          handler: (blah) => {
            console.log('Confirm Cancel: blah');
          }
        }, {
          text: 'Sim',
          handler: () => {
            for (let i = 0; i < this.listaCategoriasEscolhidas.length; i++) {
              const element = this.listaCategoriasEscolhidas[i];
              if(element.id == item.id){
                this.listaCategoriasEscolhidas.splice(i, 1);
              }
            }
            for (let i = 0; i < this.listaCategoriasEscolhidas.length; i++) {
              const element = this.listaCategoriasEscolhidas[i];
              this.categoriaEscolhida = element.id;
            }
          }
        }
      ]
    });
    await alert.present();
  }

  public cadastrarCodigoPai(){
    // inserirEcommercePAI($ID, $descricaoSimples, $descricaoCompleta, $comprimento, $altura, $largura, $status)
    this.rel_estoque.inserirEcommercePai(this.produto.title, '', this.sku, '', 0, 0, 0).then((result: any) => {
      console.log(result);
      this.loader.hideLoader();      
      this.produtoPai = result;
      // this.pesquisarProduto();
    }).catch((error: any) => {
      console.log(error);
      this.loader.hideLoader();
        //console.log('error: '+error);
      this.loader.showError('Ops', 'O seu servidor pode estar sem internet no momento, tente novamente mais tarde.');
    });
  }

  public consultarEstoque(parametro, codigo){
    let param =  {
      "parametro": parametro,
      "codigo": codigo
    }    
    // inserirEcommercePAI($ID, $descricaoSimples, $descricaoCompleta, $comprimento, $altura, $largura, $status)
    this.loader.showLoader("Consultando produto...");
    this.rel_estoque.buscarEstoquep(param).then((result: any) => {
      this.loader.hideLoader();
      // console.log(result);
      for (let i = 0; i < result.length; i++) {
        const element = result[i];
        this.sku = element.CODPROD+element.NUMERO;
        this.codBarra = element.CODBARRA;
        this.produto.available_quantity = element.TOTAL;
        this.produto.price = element.VENDA;
        for (let a = 0; a < this.tamanhosML.length; a++) {
          const elemento = this.tamanhosML[a];
          if(parseInt(element.NUMERO) == parseFloat(elemento.name)){
            this.tamanhos.push(
              {
                "attribute_combinations": 
                [{
                  "id": "SIZE",
                  "name": "Tamanho",
                  "value_id": elemento.id,
                  "value_name": elemento.name                
                },
                {
                  "id" : "COLOR",
                  "name" : "Cor",
                  "value_id" : null,
                  "value_name" : 'VERDE',
                  "value_struct" : null
                }],
                "price": element.VENDA,
              	"seller_custom_field": element.CODPROD+element.NUMERO,
                "available_quantity": element.TOTAL,
                "attributes": [
                  {"id": "EAN", 
                    "name": "EAN", 
                    "value_name": element.CODBARRA
                  },                   
                  {"id": "SELLER_SKU", 
                    "name": "SKU", 
                    "value_name": element.CODPROD+element.NUMERO
                  }
                ]                
              }
              );
          }          
        }
      }
      console.log(this.tamanhos);
      let res = {
        "data": {
          "valorEscolhido" : {
            "id": 'SELLER_SKU',
            "name": this.sku,
            "value_id": 'SKU',
            "value_name": this.sku,
          }
        }
      };

      let resa = {
        "data": {
          "valorEscolhido" : {
            "id": "GTIN",
            "name": this.codBarra,
            "value_id": 'EAN',
            "value_name": this.codBarra
          }
        }
      };
      this.validarInfo(res);      
      this.validarInfo(resa);
      
      // this.pesquisarProduto();
    }).catch((error: any) => {
      this.loader.hideLoader();        
      this.loader.showError('Ops', 'O seu servidor pode estar sem internet no momento, tente novamente mais tarde.');
    });
  }

  cadastrarProduto(){    
    this.rel_estoque.buscarFotoEcommercePai(this.produtoPai).then((result: any) => {
      this.loader.hideLoader();      
      // this.produtoPai = result;
      // this.pesquisarProduto();
      this.produto.pictures = [];
      for (let i = 0; i < result.length; i++) {
        const element = result[i];
        this.produto.pictures.push({
          "source": element.src
        });
      }
      this.confirma(this.produto);
    }).catch((error: any) => {
      this.loader.hideLoader();
        //console.log('error: '+error);
      this.loader.showError('Ops', 'O seu servidor pode esta sem internet no momento, tente novamente mais tarde.');
    });
  }

  async confirma(body) {
    const alert = await this.alertController.create({
      cssClass: 'my-custom-class',
      header: 'Confirma',
      message: 'Inserir item no Mercado Livre?',
      buttons: [
        {
          text: 'Cancelar',
          role: 'cancel',
          cssClass: 'secondary',
          handler: (blah) => {
            console.log('Confirm Cancel: blah');
          }
        }, {
          text: 'Salvar',
          handler: () => {
            console.log('Confirm Okay');
            this.inserir(body);
          }
        }
      ]
    });

    await alert.present();
  }

  inserir(body){    
    this.loader.showLoader("Cadastrando, aguarde...");
    this.rel_estoque.addMercadoLivreNew(body).then((result: any) => {
      this.loader.hideLoader();      
      console.log(result);
    }).catch((error: any) => {
      this.loader.hideLoader();
        //console.log('error: '+error);
      this.loader.showError('Ops', 'O seu servidor pode esta sem internet no momento, tente novamente mais tarde.');
    });
  }

  openModal(){
    
  }


}
