import { Component, OnInit, ViewChild } from '@angular/core';
import { AuthServiceService } from '../../providers/auth-service.service';
import { LoaderService } from '../../providers/loader.service';
import { VendasLojasService } from '../../providers/vendas-lojas.service';
//import { Chart } from 'highcharts';
import * as HighCharts from 'highcharts';
import { ActivatedRoute } from '@angular/router';
import { IonDatetime, ModalController, PopoverController } from '@ionic/angular';

import { format, parseISO } from 'date-fns';
import { ParametrosComponent } from '../../modal/parametros/parametros.component';


@Component({
  selector: 'app-pixstatus',
  templateUrl: './pixstatus.page.html',
  styleUrls: ['./pixstatus.page.scss'],
})
export class PixstatusPage implements OnInit {  
  dados2: any = [];
  banco: any;
  dados: any;
  data: any;
  foto: any;
  chart: any;
  vendas: any;
  parametro: any;  
  label: any = [];
  valores: any = {};
  CHEQUE_T: any = 0;
  CONSIGNADO_T: any = 0;
  DINHEIRO_T: any = 0; 
  DUPLICATA_T: any = 0;
  OUTROS_T: any = 0;
  POS_T: any = 0;
  RETIRADAS_T: any = 0;
  TEF_T: any = 0;
  TICKETMEDIO_T: any = 0;
  TOTAL_T: any = 0;
  TOTALDEVOLUCAO_T: any = 0;
  TOTALLIQUIDO_T: any = 0;
  QTPARC_T: any = 0;
  QTPEDIDOS_T: any = 0; 
  dadosGrafico: any = [];
  status: boolean = false;
  MARKUP_T: any = 0;
  QTITENS_T: any = 0;
  mes: any;
  hoje: any;
  dia: any;
  constructor(public loader: LoaderService, public vendasLojas: VendasLojasService, 
    public auth: AuthServiceService, private route: ActivatedRoute, public modal: ModalController,
    public popover: PopoverController) { 
    let diaAtual = new Date();
    this.mes = diaAtual.getMonth()+1;
    this.hoje = diaAtual.getDate();
    this.dia = diaAtual.getFullYear()+'-'+this.padLeft(this.mes, '0', 2)+'-'+this.padLeft(this.hoje, '0', 2);
  }

  async openModal() {
    const modal = await this.modal.create({
      component: ParametrosComponent,
      componentProps: {
        "lojas": true,
        "artigo": false,
        "grupo": false,
        "marca": false,
        "fornecedor": false,
        "dataInicial": true,
        "dataFinal": false,
        "colecao": false,
        "data": false,
        "genero": false
      },
      backdropDismiss: false,      
    });

    modal.onDidDismiss().then((res: any) => {
      this.buscarCredenciaisPIX(res.data.lj, res.data.dataInicial);
      /*
      if (res !== null) {              
        this.parametro.loja.push({"CODIGO" : res.data.lj});   
      }
      */
    });
    return await modal.present();
  }

  padLeft(text:string, padChar:string, size:number): string {
    return (String(padChar).repeat(size) + text).substr( (size * -1), size) ;
  }

  ngOnInit() {
    const data = this.route.snapshot.paramMap.get('dia');
    if(data != ''){
      // this.buscarDesempenhoVendedores(data);
    }    
  }

  formatDate(value: string) {
    return format(parseISO(value), 'MMM dd yyyy');
  }

  cancelar(e){
    
  }

  buscarCredenciaisPIX(loja, data) {
    let ar = { "idConexao": this.auth.Id, "loja": loja }     

    this.auth.buscarCredenciaisPIX(ar).then((result: any) => {
      this.loader.hideLoader();
      if(result.length > 0){
      let arb = { 
        "idConexao": this.auth.Id, 
        "loja": loja, 
        "developer_application_key" : result[0]['CEDENTEWS_KEYUSER'],
        "client_id": result[0]['CEDENTEWS_CLIENTID'],
        "client_secret": result[0]['CEDENTEWS_CLIENTSECRET'],
        "dataInicial": data,
        "dataFinal": data,
        "cnpj": result[0]['CNPJ'],
        "banco": result[0]['BANCO']
      } 
      if(result[0]['BANCO'] == "237"){
        this.banco = "https://pix.tecnodataonline.com.br/assets/img/bradesco.png"
      } else if(result[0]['BANCO'] == "001"){
        this.banco = "https://pix.tecnodataonline.com.br/assets/img/bb.png"
      } else if(result[0]['BANCO'] == "033"){
        this.banco = "https://pix.tecnodataonline.com.br/assets/img/santander.png"
      } else if(result[0]['BANCO'] == "756"){
        this.banco = "https://pix.tecnodataonline.com.br/assets/img/sicoob.png"
      } else if(result[0]['BANCO'] == "341"){
        this.banco = "https://pix.tecnodataonline.com.br/assets/img/itau.png"
      }
        this.buscarVendasRecebidas(arb);
      } else {
        this.loader.showError("Ops", "Essa loja não tem credênciais de API PIX.")

      }
    }).catch((error: any) => {
      this.loader.hideLoader();
    });
  }

  buscarVendasRecebidas(data) {
    this.vendas = [];        
    this.loader.showLoader("Buscando informações de vendas...");
    this.vendasLojas.recebimentoPIX(data).then((result: any) => {
      this.loader.hideLoader();
      this.TOTALLIQUIDO_T = 0;
      this.TOTAL_T = 0;
      this.dados2 = [];      
      if(typeof result['cobs'] !== 'undefined'){
        for (let i = 0; i < result['cobs'].length; i++) {
          const element = result['cobs'][i];
          this.dados2.push({
            "hora": element['calendario']['criacao'],
            "txid": element['txid'],
            "valor": parseFloat(element['valor']['original']),
            "status": element['status'],
            "pagador": "",
            "color": (element['status'] == "CONCLUIDA") ? "#d4f3d2" : ""
          })
        }                
        if(result['cobs'].length == 0){
          this.loader.showError("Ops", "Não encontrei PIX p/ essa data.")
        }
      }
      if(typeof result['pix'] !== 'undefined'){
        for (let i = 0; i < result['pix'].length; i++) {
          const element = result['pix'][i];
          this.dados2.push({
            "hora": element['horario'],
            "txid": element['endToEndId'],
            "valor": parseFloat(element['valor']),
            "status": 'CONFIRMADA',
            "pagador": element['pagador']['nome'],
            "color": (element['status'] == "CONCLUIDA") ? "#d4f3d2" : ""
          })
        }                
        if(result['pix'].length == 0){
          this.loader.showError("Ops", "Não encontrei PIX p/ essa data.")
        }
      }                
    }).catch((error: any) => {
      this.loader.hideLoader();
    });
  }
}
