import { Component, OnInit, ViewChild } from '@angular/core';
import { AuthServiceService } from '../../providers/auth-service.service';
import { LoaderService } from '../../providers/loader.service';
import { VendasLojasService } from '../../providers/vendas-lojas.service';
//import { Chart } from 'highcharts';
import * as HighCharts from 'highcharts';
import { ActivatedRoute } from '@angular/router';
import { IonDatetime, ModalController, PopoverController } from '@ionic/angular';

import { format, parseISO } from 'date-fns';


@Component({
  selector: 'app-resumo-diario-detalhe',
  templateUrl: './resumo-diario-detalhe.page.html',
  styleUrls: ['./resumo-diario-detalhe.page.scss'],
})
export class ResumoDiarioDetalhePage implements OnInit {  
  
  dados: any = [];
  constructor(public loader: LoaderService, public vendasLojas: VendasLojasService, 
    public auth: AuthServiceService, private route: ActivatedRoute, public modal: ModalController,
    public popover: PopoverController) { 
    
  }

  padLeft(text:string, padChar:string, size:number): string {
    return (String(padChar).repeat(size) + text).substr( (size * -1), size) ;
  }

  ngOnInit() {
    
  }

  ionViewDidEnter() {
    let data = this.route.snapshot.paramMap.get('dia');    
    this.loader.showLoader("Aguarde, consultando os detalhes das vendas...");
    this.vendasLojas.resumoDiarioDetalhe(data.substring(0,10)).then((result: any) => {
      this.dados = [];
      this.dados = result;
      this.loader.hideLoader();
    }).catch((e) => {
      this.loader.hideLoader();
      console.log(e);
    })
  }

}
