import { Component, OnInit, ViewChild } from '@angular/core';
import { AuthServiceService } from '../../providers/auth-service.service';
import { LoaderService } from '../../providers/loader.service';
import { VendasLojasService } from '../../providers/vendas-lojas.service';
//import { Chart } from 'highcharts';
import * as HighCharts from 'highcharts';
import { ActivatedRoute, NavigationExtras, Router } from '@angular/router';
import { IonDatetime, ModalController, PopoverController } from '@ionic/angular';

import { format, parseISO } from 'date-fns';


@Component({
  selector: 'app-resumo-diario',
  templateUrl: './resumo-diario.page.html',
  styleUrls: ['./resumo-diario.page.scss'],
})
export class ResumoDiarioPage implements OnInit {  
  data: any;
  foto: any;
  chart: any;
  vendas: any;
  parametro: any;  
  label: any = [];
  valores: any = {};
  CHEQUE_T: any = 0;
  CONSIGNADO_T: any = 0;
  DINHEIRO_T: any = 0; 
  DUPLICATA_T: any = 0;
  OUTROS_T: any = 0;
  POS_T: any = 0;
  RETIRADAS_T: any = 0;
  TEF_T: any = 0;
  PIX_T: any = 0;
  LINK_T: any = 0;
  TICKETMEDIO_T: any = 0;
  TOTAL_T: any = 0;
  TOTALDEVOLUCAO_T: any = 0;
  TOTALLIQUIDO_T: any = 0;
  QTPARC_T: any = 0;
  QTPEDIDOS_T: any = 0; 
  TOTALDESCONTO_T: any = 0;
  dadosGrafico: any = [];
  status: boolean = false;
  MARKUP_T: any = 0;
  QTITENS_T: any = 0;
  mes: any;
  hoje: any;
  dia: any;
  constructor(public loader: LoaderService, public vendasLojas: VendasLojasService, 
    public auth: AuthServiceService, private route: ActivatedRoute, public modal: ModalController,
    public popover: PopoverController, public router: Router) { 
    let diaAtual = new Date();
    this.mes = diaAtual.getMonth()+1;
    this.hoje = diaAtual.getDate();
    this.dia = diaAtual.getFullYear()+'-'+this.padLeft(this.mes, '0', 2)+'-'+this.padLeft(this.hoje, '0', 2);
  }

  padLeft(text:string, padChar:string, size:number): string {
    return (String(padChar).repeat(size) + text).substr( (size * -1), size) ;
  }

  ngOnInit() {
    const data = this.route.snapshot.paramMap.get('dia');
    if(data != ''){
      // console.log(data);
      this.buscarDesempenhoVendedores(data);
    }    
  }

  confirm(e){
    this.buscar(e);
  }

  formatDate(value: string) {
    return format(parseISO(value), 'MMM dd yyyy');
  }

  buscar(e){
    this.data = e;
    this.popover.dismiss();

    this.buscarDesempenhoVendedores(this.data);
  }

  cancelar(e){
    console.log(e)
  }

  doRefresh(event) {        
    setTimeout(() => {      
      event.target.complete();
      const data = this.route.snapshot.paramMap.get('dia');
      if(data != ''){
        this.buscarDesempenhoVendedores(data);
      }    
    }, 2000);
  }

  detalhar(){
    this.router.navigateByUrl('/app/tabs/schedule/resumo-diario-detalhe/'+this.data.substring(0,10));
  }

  buscarDesempenhoVendedores(data) {
    this.data = data;
    this.vendas = [];
    let ar = { "DATA": data, "LOJA": "" }
    this.parametro = data;    
    this.loader.showLoader("Buscando informações de vendas...");
    /*setTimeout(() => {
      this.loader.hideLoader();
    }, 10000);    */
    this.vendasLojas.resumoMensalDiario(ar).then((result: any) => {
      this.loader.hideLoader();      
      this.foto = this.auth.fotoLoja;
      this.dadosGrafico = [];
      this.CHEQUE_T = 0;
      this.CONSIGNADO_T = 0;
      this.DINHEIRO_T = 0; 
      this.DUPLICATA_T = 0;
      this.OUTROS_T = 0;
      this.POS_T = 0;
      this.RETIRADAS_T = 0;
      this.TEF_T = 0;
      this.TICKETMEDIO_T = 0;
      this.TOTAL_T = 0;
      this.TOTALDEVOLUCAO_T = 0;
      this.TOTALLIQUIDO_T = 0;
      this.QTPARC_T = 0;
      this.QTPEDIDOS_T = 0; 
      this.MARKUP_T = 0;
      this.QTITENS_T = 0;  
      this.PIX_T = 0;
      this.LINK_T = 0;
      this.TOTALDESCONTO_T = 0;
      this.dadosGrafico = [];      
      if(result.length != 0){
        
        for (let i = 0; i < result.length; i++) {
          const element = result[i];

          this.MARKUP_T = this.MARKUP_T + element.CUSTOMERCADORIA;
          this.QTITENS_T = this.QTITENS_T + element.QTITENS;
          this.PIX_T = this.PIX_T + element.PIX;
          this.LINK_T = this.LINK_T + element.LINK;
          this.CHEQUE_T = this.CHEQUE_T + element.CHEQUE;
          this.CONSIGNADO_T = this.CONSIGNADO_T + element.CONSIGNADO;
          this.DINHEIRO_T = this.DINHEIRO_T + element.DINHEIRO;
          this.DUPLICATA_T = this.DUPLICATA_T + element.DUPLICATA;
          this.OUTROS_T = this.OUTROS_T + element.OUTROS;
          this.POS_T = this.POS_T + element.POS;
          this.RETIRADAS_T = this.RETIRADAS_T + element.RETIRADAS;
          this.TEF_T = this.TEF_T + element.TEF;
          this.TICKETMEDIO_T = this.TICKETMEDIO_T + element.TICKETMEDIO;
          this.TOTAL_T = this.TOTAL_T + element.TOTAL;
          this.TOTALDEVOLUCAO_T = this.TOTALDEVOLUCAO_T + element.TOTALDEVOLUCAO;
          this.TOTALLIQUIDO_T = this.TOTALLIQUIDO_T + element.TOTALLIQUIDO;
          this.QTPARC_T = this.QTPARC_T + (+element.QTPARC);
          this.QTPEDIDOS_T = this.QTPEDIDOS_T + (+element.QTPEDIDOS);
          this.TOTALDESCONTO_T = this.TOTALDESCONTO_T + (element.TOTAL_DESCONTOS);

          this.vendas.push(
            { "ANO": element.ANO,
            "MES": element.MES,
            "LOJA": element.LOJA,
            "DESCLOJA": element.DESCLOJA,
            "CHEQUE": element.CHEQUE,
            "PER_CHEQUE": (+element.CHEQUE/+element.TOTALLIQUIDO)*100,
            "CONSIGNADO": element.CONSIGNADO,            
            "PER_CONSIGNADO": (+element.CONSIGNADO/+element.TOTALLIQUIDO)*100,
            "DINHEIRO": element.DINHEIRO,
            "PER_DINHEIRO": (+element.DINHEIRO/+element.TOTALLIQUIDO)*100,

            "PIX": element.PIX,
            "PER_PIX": (+element.PIX/+element.TOTALLIQUIDO)*100,

            "LINK": element.LINK,
            "PER_LINK": (+element.LINK/+element.TOTALLIQUIDO)*100,


            "DUPLICATA": element.DUPLICATA,
            "PER_DUPLICATA": (+element.DUPLICATA/+element.TOTALLIQUIDO)*100,
            "OUTROS": element.OUTROS,
            "PER_OUTROS": (+element.OUTROS/+element.TOTALLIQUIDO)*100,
            "POS": element.POS,
            "PER_POS": (+element.POS/+element.TOTALLIQUIDO)*100,
            "RETIRADAS": element.RETIRADAS,
            "PER_RETIRADAS": (+element.RETIRADAS/+element.TOTALLIQUIDO)*100,
            "TEF": element.TEF,
            "PER_TEF": (+element.TEF/+element.TOTALLIQUIDO)*100,
            "TICKETMEDIO": element.TICKETMEDIO,
            "TOTAL": element.TOTAL,
            "TOTALDEVOLUCAO": element.TOTALDEVOLUCAO,
            "PER_TOTALDEVOLUCAO": (+element.TOTALDEVOLUCAO/+element.TOTALLIQUIDO)*100,
            "TOTALLIQUIDO": element.TOTALLIQUIDO,
            "QTPARC": element.QTPARC,
            "QTPEDIDOS": element.QTPEDIDOS,
            "QTITENS": element.QTITENS,
            "MARKUP": element.TOTALLIQUIDO / element.CUSTOMERCADORIA,
            "TOTAL_DESCONTOS": element.TOTAL_DESCONTOS
            }
          )
        }        
        
        this.CHEQUE_T > 0 ? this.dadosGrafico.push({name: "Cheque", y: this.CHEQUE_T}) : "";
        this.CONSIGNADO_T > 0 ? this.dadosGrafico.push({name: "Consignado", y: this.CONSIGNADO_T}) : "";
        this.DINHEIRO_T > 0 ? this.dadosGrafico.push({name: "Dinheiro", y: this.DINHEIRO_T}) : "";
        this.PIX_T > 0 ? this.dadosGrafico.push({name: "Pix", y: this.PIX_T}) : "";
        this.LINK_T > 0 ? this.dadosGrafico.push({name: "Link", y: this.LINK_T}) : "";
        this.OUTROS_T > 0 ? this.dadosGrafico.push({name: "Outros", y: this.OUTROS_T}) : "";
        this.POS_T + this.TEF_T > 0 ? this.dadosGrafico.push({name: "Cartão", y: this.POS_T + this.TEF_T}) : "";
        this.RETIRADAS_T > 0 ? this.dadosGrafico.push({name: "Retiradas", y: this.RETIRADAS_T}) : "";        
        
       
        this.graf(this.dadosGrafico);
        
      } else {        
        
        this.loader.hideLoader();
        this.loader.presentToast("Sem vendas p/ essa data!")
        
      }
    }).catch((error: any) => {
      this.loader.hideLoader();
    });
  }

  ionViewDidEnter() {
    
  }

  graf(dadosGrafico){    
    this.status = true;
    HighCharts.chart('pieChart', {
      chart: {
        plotBackgroundColor: null,
        plotBorderWidth: null,
        plotShadow: false,
        type: 'pie'
      },
      title: {
        text: '%<br>Receb.',
        align: 'center',
        verticalAlign: 'middle'
    },
      tooltip: {
        pointFormat: '<b>R$ {point.y:.2f}</b>'
      },
      plotOptions: {
        pie: {
          dataLabels: {
              enabled: true,
              distance: -30,
              format: '<b>{point.name}</b><br>{point.percentage:.2f} %',
              style: {
                  fontWeight: 'bold',
                  color: 'white'
              }
          },
          /*startAngle: -90,
          endAngle: 90,
          center: ['50%', '75%'],*/
          size: '90%'
        }
      },      
      series: [{
        type: undefined, 
        innerSize: '50%',      
        data: dadosGrafico
    }]
    });    
  }
}
