import { Component, ElementRef, OnInit, ViewChild } from '@angular/core';

import { Platform } from '@ionic/angular';
import { Storage } from '@ionic/storage';
import { AuthServiceService } from '../../providers/auth-service.service';
import { FinanceiroLojasService } from '../../providers/financeiro-lojas.service';
import { LoaderService } from '../../providers/loader.service';

@Component({
  selector: 'app-retorno-remessa',
  templateUrl: '/retorno-remessa.page.html',
  styleUrls: ['./retorno-remessa.page.scss'],
})
export class RetornoRemessaPage implements OnInit {
  @ViewChild('pwaphoto2', { static: true }) pwaphoto: ElementRef;
  array = [];
  valorTitulo = 0;
  valorTarifa = 0;
  valorJuros = 0;
  valorRecebido = 0;
  total = 0;
  baixaAutomatica: any = [];
  dados: boolean = false;
  constructor(public auth: AuthServiceService, public financeiro: FinanceiroLojasService, public loader: LoaderService) { 
    
  }
  ngOnInit() {
    
  }

  baixarContas(){    
    this.financeiro.baixarContasReceber(this.baixaAutomatica).then((result: any) => {
      if(result == true){
        this.loader.presentToast("Contas recebidas com sucesso!");
        this.array = [];
        this.dados = false;
        this.baixaAutomatica = [];
      }
    }, (error) => {
      console.log("ERROR: ", error);
    });
  }

  addRemessa(){
    this.pwaphoto.nativeElement.click();
  }


  updateCucumber(pedido, parcela, valor, juros, tarifa, data_pagamento, loja, nossoNumero){
    let t: boolean = false;    
    let b = {
      "PEDIDO": pedido,
      "PARCELA": parcela,
      "VALOR": valor,
      "JUROS": juros,
      "TARIFA": tarifa,
      "DATA_PAGAMENTO": data_pagamento.replaceAll("/","."),
      "idConexao": this.auth.Id,
      "USUARIO_BX": this.auth.Usuario.codigo,
      "LOJA": loja,
      "NOSSONUMERO": nossoNumero
    }
    console.log(b);
    for (let i = 0; i < this.baixaAutomatica.length; i++) {
      const element = this.baixaAutomatica[i];
      //if(element.PEDIDO == pedido && element.PARCELA == parcela){
      if(element.NOSSONUMERO == nossoNumero){
        t = true;
        this.total = this.total - valor;
        this.baixaAutomatica.splice(i, 1);
      } 
    }
    if(t == false){
      this.total = this.total + valor;
      this.baixaAutomatica.push(b);
    }  
  }

  uploadPWA() {
    if (this.pwaphoto == null) {
      return;
    }
    const fileList: FileList = this.pwaphoto.nativeElement.files;
    let nome = fileList[0]['name'];    
    if (fileList && fileList.length > 0) {
      this.getBase64(fileList[0]).then((resultado) => {
        this.auth.remessa({"remessa": resultado, "nome": nome, "idConexao" : this.auth.Id}).then((result: any) => {        
          this.array = [];  
          this.valorTitulo = 0;
          this.valorTarifa = 0;
          this.valorJuros = 0;
          this.valorRecebido = 0;
          for (let i = 0; i < result.length; i++) {
            const element = result[i];             
            if(element.registro == "1"){
              this.dados = true;
              this.array.push(element);
              this.valorTitulo = this.valorTitulo + element.valor_titulo;
              this.valorTarifa = this.valorTarifa + element.valor_tarifa;
              this.valorJuros = this.valorJuros + element.juros_mora;
              this.valorRecebido = this.valorRecebido + element.valor_pagamento;
            }
          }
        }, (error) => {
          console.log("ERROR: ", error);
        });
        
      });
    }
  }

  getBase64(file) {
    return new Promise((resolve, reject) => {
      const reader = new FileReader();
      reader.readAsDataURL(file);
      reader.onload = () => resolve(reader.result);
      reader.onerror = error => reject(error);
    });
  }

}
