import { Component } from '@angular/core';
import { Storage } from '@ionic/storage';
import { AuthServiceService } from '../../providers/auth-service.service';
import { ConferenceData } from '../../providers/conference-data';

@Component({
  selector: 'page-speaker-list',
  templateUrl: 'speaker-list.html',
  styleUrls: ['./speaker-list.scss'],
})
export class SpeakerListPage {
  speakers: any[] = [];
  registerCredentials = { id: '' };
  usuario: any;
  relMapaDeVendas: boolean = true;
  cadVendedores: boolean = true;
  cadastroDeCirculaoDeClientes: boolean = true;
  mes: any;
  hoje: any;
  dia: any;

  constructor(public confData: ConferenceData, private storage: Storage, public auth: AuthServiceService) {
      
    }

  ngOnInit() {
    let diaAtual = new Date();
    this.mes = diaAtual.getMonth()+1;
    this.hoje = diaAtual.getDate();
    let dia = diaAtual.getFullYear()+'-'+this.padLeft(this.mes, '0', 2)+'-'+this.padLeft(this.hoje, '0', 2);
    // this.navCtrl.push('DetalheVendasVendedoresPage', { "DATA": dia, "LOJA": "" });
    // this.router.navigateByUrl('/app/tabs/schedule/resumo-diario');
    this.dia = dia;
    /*
    this.storage.get('mudancas').then((val) => {
      if(val != null){
        if(this.auth.modeloCelular == 'ios'){
          this.load.showError('Informação', val);
          // this.showAlert('Informação', );
        }        
      } 
    }); 
    */   
    this.storage.get('ID').then((val) => {      
      if(val != null){
        for (let i = 0; i < val.length; i++) {
          const element = val[i];
          this.registerCredentials.id = element.ID;
          this.usuario = element.NOME;            
          for (let a = 0; a < element.PERMISSOES.length; a++) {
            const elemento = element.PERMISSOES[a];
            if(elemento.MODULO == "RelatMapaDeVendasPorVendedor" && elemento.ENTRAR == "true"){
              this.relMapaDeVendas = false;
            }
            if(elemento.MODULO == "frmCadastroDeVendedores" && elemento.ENTRAR == "true"){
              this.cadVendedores = false;
            }
            if(elemento.MODULO == "FrmCadastroDeCirculaoDeClientes" && elemento.ENTRAR == "true"){
              this.cadastroDeCirculaoDeClientes = false;
            }
          }
          // console.log(element.PERMISSOES['MODULO']);
        }
      } else {
        this.usuario = this.auth.Usuario.nome;
      }
    });
    this.mes = diaAtual.getFullYear()+'-'+this.padLeft(this.mes, '0', 2);
  }

  padLeft(text:string, padChar:string, size:number): string {
    return (String(padChar).repeat(size) + text).substr( (size * -1), size) ;
  }
}
