import { Component, OnInit } from '@angular/core';
import { ActivatedRoute, NavigationExtras, Router } from '@angular/router';
import { AuthServiceService } from '../../providers/auth-service.service';
import { LoaderService } from '../../providers/loader.service';
import { VendasLojasService } from '../../providers/vendas-lojas.service';

@Component({
  selector: 'app-vendas-mensal-detalhe',
  templateUrl: './vendas-mensal-detalhe.page.html',
  styleUrls: ['./vendas-mensal-detalhe.page.scss'],
})
export class VendasMensalDetalhePage implements OnInit {
  vendasDetalhe: any;
  parametro: any;
  data: any;
  constructor(
    public loader: LoaderService, 
    public vendasLojas: VendasLojasService, 
    public auth: AuthServiceService, 
    private route: ActivatedRoute,
    private router: Router
    ) { 
      this.route.queryParams.subscribe(params => {        
        this.data = JSON.parse(params.special);        
        this.buscarDesempenhoLojas(this.data);
      });
    }

  ngOnInit() {
  }

  buscarDesempenhoLojas(data) {
    this.loader.showLoader("Buscando detalhe das vendas...")    
    this.vendasLojas.resumoMensalSimples(data)
    .then((result: any) => {
      this.vendasDetalhe = [];          
      this.vendasDetalhe = result;
      this.loader.hideLoader();
    })
    .catch((error: any) => {
      this.loader.hideLoader();
    });
  }

  detalharVendedores(e){    
    let navigationExtras: NavigationExtras = {
      queryParams: {
        special: JSON.stringify(e.DATA)
      }
    };
    this.router.navigate(['/app/tabs/schedule/resumo-mensal'], navigationExtras);
  }

}
