import { Component, OnInit } from '@angular/core';
import { ActivatedRoute, Router } from '@angular/router';
import { LoaderService } from '../../providers/loader.service';
import { VendasLojasService } from '../../providers/vendas-lojas.service';

@Component({
  selector: 'app-vendedores-desempenho-detalhe',
  templateUrl: './vendedores-desempenho-detalhe.page.html',
  styleUrls: ['./vendedores-desempenho-detalhe.page.scss'],
})
export class VendedoresDesempenhoDetalhePage implements OnInit {
  loading: any;
  parametro: any;
  nomeVendedor: any;
  vendas: any;
  vendasMarca: any;
  vendasGrupo: any;
  // chart = new Chart({});
  // chartMarca = new Chart({});
  // chartGrupo = new Chart({});
  public data = {
    id : ""
  }
  // barChart: any = new Chart({});

  constructor(private route: ActivatedRoute,
    private router: Router, public vendasL: VendasLojasService, public loader: LoaderService) { 
    this.route.queryParams.subscribe(params => {
      // console.log(params); 
      this.parametro = JSON.parse(params.special);
      // this.nomeVendedor = params.
      // this.data = JSON.parse(params.special);        
      // this.buscarDesempenhoLojas(this.data);
    });
  }

  ngOnInit() {
    
    this.vendedoresPorArtigo(this.parametro);
    this.vendedoresPorMarca(this.parametro);
    this.vendedoresPorGrupo(this.parametro);
    
  }

  vendedoresPorMarca(parametro){

    this.vendasMarca = [];
    this.vendasL.vendedoresPorMarca(parametro)
    .then((result: any) => {
      this.loading = true;
        if(result.length == 0){
          this.loader.presentToast("Não encontrei nada por marca!");
        } else {
            for (let i = 0; i < result.length/*9*/; i++) {
                const element = result[i];
                this.vendasMarca.push({
                    name: element.MARCA,
                    y: element.QT,
                    x: element.VALOR
                });
            }
          // this.grafMarca(this.vendasMarca)        
        }
      })
      .catch((error: any) => {
        console.log('error: '+error);
      });
  }

  vendedoresPorArtigo(parametro){
    this.vendas = [];
    this.vendasL.vendedoresPorArtigo(parametro)
    .then((result: any) => {      
      this.loading = true;
        if(result.length == 0){
          this.loader.presentToast("Não encontrei nada por artigo!")
        }
        for (let i = 0; i < result.length; i++) {
            const element = result[i];
            this.vendas.push({
                name: element.ARTIGO,
                y: element.QT,
                x: element.VALOR
            });
        }
        // this.graf(this.vendas)        
      })
      .catch((error: any) => {
        console.log('error: '+error);
      });
  }

  vendedoresPorGrupo(parametro){
    this.vendasGrupo = [];
    this.vendasL.vendedoresPorGrupo(parametro)
    .then((result: any) => { 
      this.loading = true;  
        if(result.length == 0){
          this.loader.presentToast("Não encontrei nada por grupo!")
        }
        for (let i = 0; i < result.length/*9*/; i++) {
            const element = result[i];
            this.vendasGrupo.push({
                name: element.GRUPO,
                y: element.QT,
                x: element.VALOR
            });
        }
        // this.grafGrupo(this.vendasGrupo)        
      })
      .catch((error: any) => {
        console.log('error: '+error);
      });
  }


}
