import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { AuthServiceService } from './auth-service.service';

@Injectable({
  providedIn: 'root'
})
export class ClientesLojasService {

  public Parametro = {
    id: '',
    mesAno: '',
    loja: '',    
    data_inicial: '',
    data_final: '',
    data : {
      year: '',
      month: '',
      day: ''
    },
    parametro: '',
    qt_pedidos: '',
    ticketmedio: '',
    codclie: '',
    sessionName: '',
    number: '',
    text: ''
  }

  constructor(private http: HttpClient, public auth: AuthServiceService) { }

  vendasPorClientes(credentials) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);      
    } else {      
      this.Parametro.id = this.auth.Id;      
      this.Parametro.data_inicial = credentials['dataInicial'];
      this.Parametro.data_final = credentials['dataFinal'];
      this.Parametro.parametro = credentials;
      this.Parametro.ticketmedio = credentials['ticketMedio'];
      this.Parametro.qt_pedidos = credentials['qtMinima'];
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/melhoresClientes', this.Parametro)
        .subscribe((result: any) => {
          
          resolve(result);          
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  detalheVendasPorClientesArtigos(credentials) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);      
    } else {      
      this.Parametro.id = this.auth.Id;      
      this.Parametro.codclie = credentials['CODCLIE'];
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/detalheDesempenhoDeClientesArtigo', this.Parametro)
        .subscribe((result: any) => {          
          resolve(result);          
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  detalheVendasPorClientesMarcas(credentials) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);      
    } else {      
      this.Parametro.id = this.auth.Id;      
      this.Parametro.codclie = credentials['CODCLIE'];
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/detalheDesempenhoDeClientesMarca', this.Parametro)
        .subscribe((result: any) => {          
          resolve(result);          
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  detalheVendasPorClientesGrupos(credentials) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);      
    } else {      
      this.Parametro.id = this.auth.Id;      
      this.Parametro.codclie = credentials['CODCLIE'];
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/detalheDesempenhoDeClientesGrupo', this.Parametro)
        .subscribe((result: any) => {          
          resolve(result);          
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  detalheVendasPorClientesTamanhos(credentials) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);      
    } else {      
      this.Parametro.id = this.auth.Id;      
      this.Parametro.codclie = credentials['CODCLIE'];
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/detalheDesempenhoDeClientesTamanho', this.Parametro)
        .subscribe((result: any) => {          
          resolve(result);          
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  enviarEmail(credentials) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);      
    } else {
      credentials['id'] = this.auth.Id;
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/enviarEmail', credentials)
        .subscribe((result: any) => {          
          resolve(result);          
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  fluxoDeClientes(credentials) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);      
    } else {      
      this.Parametro.id = this.auth.Id;  
      this.Parametro.data_inicial = credentials['data_inicial'];
      this.Parametro.data_final = credentials['data_final'];
      this.Parametro.loja = credentials['loja'];
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/fluxoDeClientes', this.Parametro)
        .subscribe((result: any) => {          
          resolve(result);          
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  consultarQualidadeBaseClientes(credentials) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);      
    } else {      
      this.Parametro.id = this.auth.Id;      
      this.Parametro.data_inicial = credentials['data_inicial'];
      this.Parametro.data_final = credentials['data_final'];
      this.Parametro.loja = credentials['loja'];
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/consultarQualidadeBaseClientes', this.Parametro)
        .subscribe((result: any) => {          
          resolve(result);          
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  consultarClientesSemComprar() {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);      
    } else {      
      this.Parametro.id = this.auth.Id;
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/consultarClientesSemComprar', this.Parametro)
        .subscribe((result: any) => {          
          resolve(result);          
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  consultarBonusCliente() {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);      
    } else {      
      this.Parametro.id = this.auth.Id;
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/consultarBonusCliente', this.Parametro)
        .subscribe((result: any) => {          
          resolve(result);          
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  insertClientesMKT(arr) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);      
    } else {      
      this.Parametro.id = this.auth.Id;
      this.Parametro.parametro = arr;
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/insertClientesMKT', this.Parametro)
        .subscribe((result: any) => {          
          resolve(result);          
        },
        (error) => {
          reject(error);
        });
      });
    }
  }
  
  padLeft(text:string, padChar:string, size:number): string {
    return (String(padChar).repeat(size) + text).substr( (size * -1), size) ;
  }

  consultaTodosClientes(credentials) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);      
    } else {      
      this.Parametro.id = this.auth.Id;      
      this.Parametro.codclie = credentials['CODCLIE'];
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/consultaTodosClientes', this.Parametro)
        .subscribe((result: any) => {          
          resolve(result);          
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  verificarWhatsApp(session){
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);      
    } else {
      return new Promise((resolve, reject) => {
        this.http.get("http://192.168.1.15:3000/start?sessionName="+session).subscribe(
        resultado => {
          // resolve(resultado);
        },
        erro => {
          if(erro.status == 404) {
            console.log('Produto não localizado.');
          }
        }
        );
      })
    }
  }

  buscarQRCodeWhatsApp(session){
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);      
    } else {
      return new Promise((resolve, reject) => {
        this.http.get("http://192.168.1.15:3000/qrcode?sessionName="+session).subscribe(
        resultado => {
          // resolve(resultado);
        },
        erro => {
          if(erro.status == 404) {
            console.log('Produto não localizado.');
          }
        }
        );
      })
    }
  }

  enviarMsgWhatsApp(texto, telefone) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);      
    } else {
      let arr = {
        "sessionName" : this.auth.Usuario.CNPJ, 
        "number" : telefone,
        "text" : texto
      }

      const headers = {        
        'Content-Type': 'application/json',
        'Accept': 'application/json',
      };
      
      return new Promise((resolve, reject) => {
        this.http.post("http://192.168.1.15:3000/sendText", arr).subscribe(
        resultado => {
          // resolve(resultado);
        },
        erro => {
          if(erro.status == 404) {
            console.log('Produto não localizado.');
          }
        }
        );
      })
    }
  }
}
