import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { AuthServiceService } from './auth-service.service';

@Injectable({
  providedIn: 'root'
})
export class ModuloService {
  public Parametro = {
    id: '',
    usuario: '',
    modulo: '',
    sugestao: ''
  }
  constructor(public auth: AuthServiceService, private http: HttpClient) { }

  consultarModulo(credentials) {
    //credentials.push(this.auth.Id);
    if(this.auth.URL == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);
    } else {
      this.Parametro.id = this.auth.Id;
      this.Parametro.usuario = this.auth.Usuario.codigo; 
      this.Parametro.modulo = credentials;
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/consultarPermissaoModulo', this.Parametro)
        .subscribe((result: any) => {
          resolve(result.json());
        },
        (error) => {
          reject(error.json());
        });
      });
    }
  }

  consultarPIX(credentials) {
    //credentials.push(this.auth.Id);
    if(this.auth.URL == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);
    } else {
      this.Parametro.id = this.auth.Id;
      this.Parametro.usuario = this.auth.Usuario.codigo; 
      this.Parametro.modulo = credentials;
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/buscarChavePIX', this.Parametro)
        .subscribe((result: any) => {
          resolve(result.json());
        },
        (error) => {
          reject(error.json());
        });
      });
    }
  }

  inserirPIX(credentials) {
    //credentials.push(this.auth.Id);
    if(this.auth.URL == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);
    } else {      
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/inserirChavePIX', credentials)
        .subscribe((result: any) => {
          resolve(result.json());
        },
        (error) => {
          reject(error.json());
        });
      });
    }
  }

  public sugestoesConsultar(){
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);     
    } else {      
      this.Parametro.id = this.auth.Id;
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/consultarSugestoes', this.Parametro)
        .subscribe((result: any) => {          
          resolve(result.json());          
        },
        (error) => {
          reject(error.json());
        });
      });
    }
  }

  public sugestoes(data){
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);  
    } else {      
      this.Parametro.id = this.auth.Id;
      this.Parametro.sugestao = data['texto'];
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/sugestoes', this.Parametro)
        .subscribe((result: any) => {          
          resolve(result.json());          
        },
        (error) => {
          reject(error.json());
        });
      });
    }
  }
}
