import { HttpClient } from '@angular/common/http';
import { Injectable, OnInit } from '@angular/core';
import { AuthServiceService } from './auth-service.service';

@Injectable({
  providedIn: 'root'
})
export class VendasLojasService {
  
  public Parametro = {
    id: '',
    mesAno: '',
    loja: '',
    // data: '',
    data_inicial: '',
    data_final: '',
    data : {
      year: '',
      month: '',
      day: ''
    },
    parametro: '',
    qt_pedidos: '',
    ticketmedio: '',
    vendedor: '',
    usuario: '',
    pedido: '',
    pedidoShopee: '',
    idConexao: '',
    dataNF: '',
    numeroNF: '',
    chaveNF: '',
    idPedido: '',
    serieNF: '',
    rastreio: '',
    tipo: '',
    transportadora: ''
  }
  constructor(public auth: AuthServiceService, private http: HttpClient) { }

  inserirTransporte(a) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);
    } else {
      //credentials.push(this.auth.Id);
      this.Parametro.id = this.auth.Id;
      this.Parametro.chaveNF = a.CHAVE;
      this.Parametro.numeroNF = a.NUMERO;
      this.Parametro.serieNF = '001';
      this.Parametro.dataNF = a.DATANF;
      this.Parametro.idPedido = a.VALOR;
      this.Parametro.pedido = a.PEDIDO;
      
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/inserirNFePluggto', this.Parametro)
        .subscribe((result: any) => {
          resolve(result);
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  inserirNF(a) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);
    } else {
      //credentials.push(this.auth.Id);
      this.Parametro.id = this.auth.Id;
      this.Parametro.chaveNF = a.CHAVE;
      this.Parametro.numeroNF = a.NUMERO;
      this.Parametro.serieNF = '001';
      this.Parametro.dataNF = a.DATANF;
      this.Parametro.idPedido = a.VALOR;
      this.Parametro.pedido = a.PEDIDO;
      
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/inserirNFePluggto', this.Parametro)
        .subscribe((result: any) => {
          resolve(result);
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  imprimirEtiquetas(a) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);
    } else {
      //credentials.push(this.auth.Id);
      this.Parametro.id = this.auth.Id;
      this.Parametro.chaveNF = a.CHAVE;
      this.Parametro.numeroNF = a.NUMERO;
      this.Parametro.serieNF = '001';
      this.Parametro.dataNF = a.DATANF;
      this.Parametro.idPedido = a.VALOR;
      this.Parametro.pedido = a.PEDIDO;
      
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/imprimirEtiquetasPluggto', this.Parametro)
        .subscribe((result: any) => {
          resolve(result);
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  consultarUnicoPedidoPluggto(a) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);
    } else {
      //credentials.push(this.auth.Id);
      this.Parametro.id = this.auth.Id;
      this.Parametro.chaveNF = a.CHAVE;
      this.Parametro.numeroNF = a.NUMERO;
      this.Parametro.serieNF = '001';
      this.Parametro.dataNF = a.DATANF;
      this.Parametro.idPedido = a.VALOR;
      this.Parametro.pedido = a.PEDIDO;
      
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/consultarUnicaVendaPluggto', this.Parametro)
        .subscribe((result: any) => {
          resolve(result);
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  inserirRastreio(a) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);
    } else {
      //credentials.push(this.auth.Id);
      this.Parametro.id = this.auth.Id;      
      this.Parametro.idPedido = a.idPedido;
      this.Parametro.pedido = a.pedido;
      this.Parametro.transportadora = a.transportadora;
      this.Parametro.tipo = a.tipo;
      this.Parametro.rastreio = a.rastreio;
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/inserirTransportePluggto', this.Parametro)
        .subscribe((result: any) => {
          resolve(result);
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  desempenhoLojas(credentials) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);
    } else {
      //credentials.push(this.auth.Id);
      this.Parametro.id = this.auth.Id;
      this.Parametro.mesAno = credentials;
      if(this.auth.Usuario.somenteLojaLocal == true){
        this.Parametro.loja = this.auth.Usuario.loja;      
      } else {
        this.Parametro.loja = credentials['LOJA'];      
      }
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/desempenhoVendas', this.Parametro)
        .subscribe((result: any) => {
          resolve(result);
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  vendasPluggTO(credentials) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);
    } else {
      //credentials.push(this.auth.Id);
      this.Parametro.id = this.auth.Id;
      this.Parametro.mesAno = credentials;
      if(this.auth.Usuario.somenteLojaLocal == true){
        this.Parametro.loja = this.auth.Usuario.loja;      
      } else {
        this.Parametro.loja = credentials['LOJA'];      
      }
      // console.log(this.Parametro);
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/consultarVendasPluggto', this.Parametro)
        .subscribe((result: any) => {
          resolve(result);
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  desempenhoVendedoresPDV(credentials) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);
    } else {

      this.Parametro.id = this.auth.Id;
      this.Parametro.data_inicial = credentials['data_inicial'];
      this.Parametro.data_final = credentials['data_final'];
      if(this.auth.Usuario.somenteLojaLocal == true){
        this.Parametro.loja = this.auth.Usuario.loja;
      }
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/desempenhoVendedoresSinteticoPDV', this.Parametro)
        .subscribe((result: any) => {
          if(result._body != ""){
            resolve(result);
          }          
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  resumoDiarioDetalhe(data){
    this.Parametro.id = this.auth.Id;
    this.Parametro.data_inicial = data;
    return new Promise((resolve, reject) => {
      this.http.post(this.auth.URL + '/resumoDiarioDetalhe', this.Parametro)
      .subscribe((result: any) => {
        resolve(result);          
      },
      (error) => {
        reject(error.text);
      });
    });
    
  }

  resumoMensalSimples(credentials) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);
    } else {

      this.Parametro.id = this.auth.Id;
      this.Parametro.mesAno = credentials['ANO']+'-'+this.padLeft(credentials['MES'], '0', 2);
      this.Parametro.loja = credentials['LOJA'];
      
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/resumoMensalSimples', this.Parametro)
        .subscribe((result: any) => {
          resolve(result);          
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  resumoVendasPorVendedoresSimples(credentials) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);
    } else {

      this.Parametro.id = this.auth.Id;
      this.Parametro.data = credentials['DATA'];
      this.Parametro.loja = credentials['LOJA'];
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/desempenhoVendasVendedores', this.Parametro)
        .subscribe((result: any) => {
          resolve(result);
          
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  graficoDeVendas(codloja) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);
    } else {
      this.Parametro.id = this.auth.Id;
      if(this.auth.Usuario.somenteLojaLocal == true){
        this.Parametro.loja = this.auth.Usuario.loja;      
      } else {
        this.Parametro.loja = codloja;
      } 
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/graficoAnual', this.Parametro)
        .subscribe((result: any) => {
          resolve(result);
          
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  resumoMensalDiario(credentials) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);
    } else {

      this.Parametro.id = this.auth.Id;
      // return this.data.substr(8,2)+"/"+this.data.substr(5,2)+"/"+this.data.substr(0,4);
      this.Parametro.data.day = credentials['DATA'].substr(8,2);
      this.Parametro.data.month = credentials['DATA'].substr(5,2);
      this.Parametro.data.year = credentials['DATA'].substr(0,4);
      if(this.auth.Usuario.somenteLojaLocal == true){
        this.Parametro.loja = this.auth.Usuario.loja;      
      } else {
        this.Parametro.loja = credentials['LOJA'];      
      }
      // console.log(this.Parametro);
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/buscarResumop', this.Parametro)
        .subscribe((result: any) => {
          resolve(result);          
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  recebimentoPIX(credentials) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      
    } else {   
      // console.log(this.Parametro);
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/pixbbConsultarPeriodo', credentials)
        .subscribe((result: any) => {
          resolve(result);          
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  comparativoVendasHoraDia(credentials) {
    // this.auth.Id = '53';
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);
    } else {      
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/comparativoVendasHoraDia', credentials)
        .subscribe((result: any) => {
          resolve(result);          
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  lucratividade(credentials) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);
    } else {
      this.Parametro.id = this.auth.Id;
      this.Parametro.data_inicial = credentials['data_inicial'];
      this.Parametro.data_final = credentials['data_final'];
      if(this.auth.Usuario.somenteLojaLocal == true){
        this.Parametro.loja = this.auth.Usuario.loja;      
      } 
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/lucratividadeEmpresa', this.Parametro)
        .subscribe((result: any) => {
          resolve(result);          
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  vendasPorCampanhas(credentials) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);
    } else {
      this.Parametro.id = this.auth.Id;
      this.Parametro.data_inicial = credentials['data_inicial'];
      this.Parametro.data_final = credentials['data_final'];
      
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/vendasPorCampanha', this.Parametro)
        .subscribe((result: any) => {
          resolve(result);          
        },
        (error) => {
          reject(error);
        });
      });
    }
  }
  
  comparativoDeVendas(credentials) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);
    } else {
      this.Parametro.id = this.auth.Id;
      this.Parametro.data_inicial = credentials['data_inicial'];
      this.Parametro.data_final = credentials['data_final'];  
      this.Parametro.parametro = credentials['parametro']; 
      // console.log(this.Parametro); 
      if(this.auth.Usuario.somenteLojaLocal == true){
        this.Parametro.loja = this.auth.Usuario.loja;      
      }
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/comparativoDeVendas', this.Parametro)
        .subscribe((result: any) => {
          resolve(result);          
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  vendedoresPorArtigo(credentials) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);
    } else {
      this.Parametro.id = this.auth.Id;
      this.Parametro.data_inicial = credentials['data_inicial'];
      this.Parametro.data_final = credentials['data_final'];  
      this.Parametro.vendedor = credentials['vendedor'];  
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/vendasPorArtigoVendedor', this.Parametro)
        .subscribe((result: any) => {
          resolve(result);          
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  vendedoresPorMarca(credentials) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);
    } else {
      this.Parametro.id = this.auth.Id;
      this.Parametro.data_inicial = credentials['data_inicial'];
      this.Parametro.data_final = credentials['data_final'];  
      this.Parametro.vendedor = credentials['vendedor'];  
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/vendasPorMarcaVendedor', this.Parametro)
        .subscribe((result: any) => {
          resolve(result);          
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  vendedoresPorGrupo(credentials) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);
    } else {
      this.Parametro.id = this.auth.Id;
      this.Parametro.data_inicial = credentials['data_inicial'];
      this.Parametro.data_final = credentials['data_final'];  
      this.Parametro.vendedor = credentials['vendedor'];  
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/vendasPorGrupoVendedor', this.Parametro)
        .subscribe((result: any) => {
          resolve(result);          
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  fluxoDeCaixa(credentials) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);
    } else {
      this.Parametro.id = this.auth.Id;
      this.Parametro.data_inicial = credentials['data_inicial'];
      this.Parametro.data_final = credentials['data_final'];  
      this.Parametro.parametro = credentials['parametro'];
      this.Parametro.loja = credentials['loja'];          
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/fluxoDeCaixa', this.Parametro)
        .subscribe((result: any) => {
          resolve(result);          
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  vendasCampanha(credentials) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);
    } else {
      this.Parametro.id = this.auth.Id;      
      this.Parametro.parametro = credentials;  
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/buscarDesempenhoCampanha', this.Parametro)
        .subscribe((result: any) => {
          resolve(result);          
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  consultarPedidoParaProvacao(credentials) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);
    } else {
      this.Parametro.id = this.auth.Id;      
      this.Parametro.parametro = credentials;
      this.Parametro.usuario = this.auth.Usuario.codigo;
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/consultarPedidoParaProvacao', this.Parametro)
        .subscribe((result: any) => {
          resolve(result);          
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  consultarPedidoParaProvacaoItens(credentials) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);
    } else {
      this.Parametro.id = this.auth.Id;      
      this.Parametro.pedido = credentials;      
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/consultarPedidoParaProvacaoItens', this.Parametro)
        .subscribe((result: any) => {
          resolve(result);          
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  atualizarPedidoParaProvacaoItens(credentials) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);
    } else {      
      credentials[0]['id'] =  this.auth.Id;      
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/autorizarPedidoParaProvacao', credentials)
        .subscribe((result: any) => {
          resolve(result);          
        },
        (error) => {
          reject(error);
        });
      });
    }
  }


  buscarVendasShopee() {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);
    } else {      
      this.Parametro.idConexao = this.auth.Id;
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/consultarVendasShopee', this.Parametro)
        .subscribe((result: any) => {
          resolve(result);          
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

    addVendasShopee(pedido) {
      if(this.auth.Id == '' || this.auth.Id == undefined){
        //const root = this.app.getRootNav();
        //root.setRoot('LoginPage');
        //return new Promise(null);
      } else {            
        this.Parametro.pedidoShopee = pedido;
        this.Parametro.idConexao = this.auth.Id;
        return new Promise((resolve, reject) => {
          this.http.post(this.auth.URL + '/inserirVendaShopee', this.Parametro)
          .subscribe((result: any) => {
            resolve(result);          
          },
          (error) => {
            reject(error);
          });
        });
      }
  }

  consutarCorreios(parametro) {    
    return new Promise((resolve, reject) => {
      this.http.post(this.auth.URL + '/buscarVendasCorreios', parametro)
        .subscribe((result: any) => {
          if(result._body != ""){
            resolve(result);            
          }
        },
        (error) => {
          reject(error);
        });
    });
  }

  inserirCorreios(parametro) {    
    return new Promise((resolve, reject) => {
      this.http.post(this.auth.URL + '/atualizarPedidoWP', parametro)
        .subscribe((result: any) => {
          if(result._body != ""){
            resolve(result);            
          }
        },
        (error) => {
          reject(error);
        });
    });
  }

  vendasComparativoSemana(param) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);
    } else {                  
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/vendasPorSemana', param)
        .subscribe((result: any) => {
          resolve(result);          
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  manutencaoDeVendas(param) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);
    } else {      
      this.Parametro.pedido = param.codigo;
      this.Parametro.parametro = param.parametro;
      this.Parametro.id = this.auth.Id;     
      console.log(this.Parametro);       
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/manutencaoDeVendas', this.Parametro)
        .subscribe((result: any) => {
          resolve(result);          
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  manutencaoDeVendasUpdate(param) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);
    } else {      
      this.Parametro.pedido = param;
      this.Parametro.id = this.auth.Id;            
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/manutencaoDeVendasUpdate', param)
        .subscribe((result: any) => {
          resolve(result);          
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  cancelarVenda(param) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);
    } else {      
      this.Parametro.pedido = param.pedido;
      this.Parametro.id = this.auth.Id;            
      this.Parametro.loja = param.codLoja;
      console.log(this.Parametro);
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/cancelarVenda2', this.Parametro)
        .subscribe((result: any) => {
          resolve(result);          
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  manutencaoDeReceUpdate(param) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);
    } else {
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/updateContasReceberTipodoc', param)
        .subscribe((result: any) => {
          resolve(result);          
        },
        (error) => {
          reject(error);
        });
      });
    }
  }

  buscarTipoDocumento(param) {
    if(this.auth.Id == '' || this.auth.Id == undefined){
      //const root = this.app.getRootNav();
      //root.setRoot('LoginPage');
      //return new Promise(null);
    } else {      
      this.Parametro.pedido = param;
      this.Parametro.id = this.auth.Id;            
      return new Promise((resolve, reject) => {
        this.http.post(this.auth.URL + '/consultaTipoDeDocumento', param)
        .subscribe((result: any) => {
          resolve(result);          
        },
        (error) => {
          reject(error);
        });
      });
    }
  }
  


  padLeft(text:string, padChar:string, size:number): string {
    return (String(padChar).repeat(size) + text).substr( (size * -1), size) ;
  }
}
